{$R-,V-,A+}
{$M 4000,0,65000}
PROGRAM NonaPlay;

USES Crt,Dos,NonadLib;

CONST
  Error:ARRAY[1..8] OF STRING=
  ('Chargement impossible      ',
   'Pas assez de mmoire       ',
   'Module non trouv          ',
   'Taille du module incorrecte',
   'Signature FM9 incorrecte   ',
   'Erreur dans instrument     ',
   'Erreur dans taille voix    ',
   'Erreur dans vnement      ');

 VAR
   Counter   :WORD;
   Regs      :Registers;
   Error_Code:BYTE;
   Character :Char;
   Volume    :BYTE;
   SBPort    :WORD;
   Mixer     :BOOLEAN;


 FUNCTION SB_Test:BOOLEAN;
 CONST
  NrTimes  =10;
  NrTimes2 =50;
 VAR
  Found    :BOOLEAN;
  Counter1,
  Counter2 :WORD;
 BEGIN
   SBPort  :=$210;
   Found   :=False;
   Counter1:=NrTimes;
   WHILE (SBPort<=$260) AND NOT Found DO
   BEGIN
     Port[SBPort+$6]:=1;
     Port[SBPort+$6]:=0;
     Counter2:=NrTimes2;
     WHILE (Counter2>0) AND (Port[SBPort+$E]<128) DO
       Dec(Counter2);
     IF (Counter2=0) OR (Port[SBPort+$A]<>$AA) THEN
     BEGIN
       Dec(Counter1);
       IF (Counter1=0) THEN
       BEGIN
         Counter1:=NrTimes;
         SBPort  :=SBPort+$10;
       END
     END
     ELSE Found:=True;
   END;
   IF Found THEN
     SB_Test:=True
   ELSE SB_Test:=False;
 END;


 PROCEDURE Write_Mixer(Reg,Val:BYTE);
  BEGIN
    Port[SBPort+$04]:=Reg;
    Port[SBPort+$05]:=Val;
  END;


 FUNCTION Read_Mixer(Reg:BYTE):BYTE;
  BEGIN
    Port[SBPort+$04]:=Reg;
    Read_Mixer:=Port[SBPort+$05];
  END;


 FUNCTION Mixer_Test:BOOLEAN;
  BEGIN
    Mixer_Test:=False;
    Mixer     :=False;
    Write_Mixer($22,$F3);
    IF Read_Mixer($22)=$F3 THEN
    BEGIN
      Mixer_Test:=True;
      Mixer     :=True;
      Write_Mixer($22,$99);
    END;
  END;


 PROCEDURE Change_Volume;
  BEGIN
    Write_Mixer($22,Volume OR (Volume SHL 4));
    GoToXY(17,9); Write(Volume:2);
  END;


 PROCEDURE Increase_Volume;
  BEGIN
    IF Mixer THEN
    BEGIN
      IF Volume<15 THEN Inc(Volume);
      Change_Volume;
    END;
  END;


 PROCEDURE Decrease_Volume;
  BEGIN
    IF Mixer THEN
    BEGIN
      IF Volume>1 THEN Dec(Volume);
      Change_Volume;
    END;
  END;


 PROCEDURE Cursor_OFF;
  BEGIN
    Regs.AH:=$01;
    Regs.CH:=$20;
    Regs.CL:=$20;
    Intr($10,Regs);
  END;


 PROCEDURE Cursor_ON;
  BEGIN
    Regs.AH:=$01;
    Regs.CH:=$06;
    Regs.CL:=$07;
    Intr($10,Regs);
  END;


 PROCEDURE Init;
  BEGIN
    ClrScr;
    Volume:=$9;
    IF AdLib_Test=False THEN
    BEGIN
      WriteLn('Carte AdLib non dtecte!');
      Halt;
    END;
    IF ParamCount=0 THEN
    BEGIN
      WriteLn('Module FM9 non prcis!');
      Halt;
    END;
    Error_Code:=Load_Music(ParamStr(1)+'.fm9');
    IF Error_Code<>0 THEN
    BEGIN
      WriteLn('Erreur ',Error_Code,': ',Error[Error_Code]);
      Halt;
    END;
  END;


 PROCEDURE Screen;
  BEGIN
    Cursor_OFF;
    WriteLn(' NONAPLAY v1.0 [Joueur de FM9] - P.Ruelle/GRYPHAEA 94');
    WriteLn;
    WriteLn(' FM    Chipset:  OK');
    Write  (' DSP   Chipset: ');
    IF SB_Test THEN WriteLn(' OK') ELSE WriteLn('NOK');
    Write  (' MIXER Chipset: ');
    IF Mixer_Test THEN WriteLn(' OK') ELSE WriteLn('NOK');
    WriteLn;
    WriteLn(' Nom du module: ',ParamStr(1)+'.fm9');
    WriteLn(' Compteur.....:');
    WriteLn(' Volume.......:  9');
    IF Mixer THEN Change_Volume;
    Start_Music;
    GoToXY(2,11); WriteLn('P. Interrompre (PAUSE)');
    GoToXY(2,12); WriteLn('C. Reprendre (CONTINUE)');
    GoToXY(2,13); WriteLn('Q. Arrter/Quitter');
    GoToXY(2,14); WriteLn('+. Augmenter Volume');
    GoToXY(2,15); WriteLn('-. Diminuer Volume');
    Counter  :=0;
    Character:=' ';
  END;


 PROCEDURE Menu;
  BEGIN
    REPEAT
      GoToXY(17,8); Write(Counter:5);
      Inc(Counter);
      IF KeyPressed THEN
      BEGIN
        Character:=ReadKey;
        Character:=UpCase(Character);
        CASE Character OF
          'P': Pause_Music;
          'C': Continue_Music;
          'Q': Stop_Music;
          '+': Increase_Volume;
          '-': Decrease_Volume;
        END;
      END;
    UNTIL Character='Q';
    Cursor_ON;
    IF Mixer THEN
    BEGIN
      Volume:=$9;
      Change_Volume;
    END;
    ClrScr;
  END;


 BEGIN { NONAPLAY }
   Init;
   Screen;
   Menu;
 END. { NONAPLAY }