{$M 4000,0,65000}
PROGRAM SC9enFM9;

 USES Crt;

 CONST

   L_Notes:Array[1..36] Of String[4]=
   ('DO  ','DO# ','REB ','RE  ','RE# ','MIB ','MI  ','FA  ','FA# ','SOLB',
    'SOL ','SOL#','LAB ','LA  ','LA# ','SIB ','SI  ','S   ','C   ','C#  ',
    'DB  ','D   ','D#  ','EB  ','E   ','F   ','F#  ','GB  ','G   ','G#  ',
    'AB  ','A   ','A#  ','BB  ','B   ','    ');

   Code   :Array[1..36] Of Byte=
   (1,2,2,3,4,4,5,6,7,7,8,9,9,10,11,11,12,13,1,2,2,3,4,4,5,6,7,7,8,9,9,
   10,11,11,12,13);

   Ffi:String='Fin de fichier inattendue';
   Efi:String='Ecriture disque impossible';

 TYPE
   Bl  =^Blo;
   Blo =Array[1..65018] Of Byte;
   SBIFormat =RECORD
                Sound_Params,Level,Attack_Rate,
                Release_Rate,Wave_Type         :Array[1..2] Of Byte;
                Feedback:Byte;
              END;
   String8=String[8];

 VAR
   File1      :Text;
   File2      :File;
   Filename1,
   Filename2  :String;
   Chain,
   Aux,Aux2   :String;
   Aux3       :String[4];
   bloc       :Bl;
   Len        :Byte;
   ce         :Integer;
   cnt        :Byte;
   Next_Elem  :Word;
   Total_Ticks:Array[1..9] Of LongInt;
   T_Exec     :LongInt;
   E_Voic     :Array[1..9] Of Word;
   E_Total    :Word;
   Title      :String[32];
   Message    :String[64];
   Nber_Inst  :Byte;
   Nber_Voic  :Byte;
   Nber_Tick  :Byte;
   L_Inst     :Array[1..64] Of SBIFormat;
   L_Names    :Array[1..64] Of String8;
   Nber_Event :Word;


 PROCEDURE Read_Params;
  VAR
    Filename:String;
  BEGIN
    IF ParamCount=1
    THEN Filename:=ParamStr(1)
    ELSE BEGIN
           WriteLn('Usage: SC9enFM9 NomFichier');
           Halt;
         END;
    Filename1:=Filename+'.SC9';
    Filename2:=Filename+'.FM9';
  END;


 PROCEDURE Error1(Number:Byte; Info:String; Line:Word);
  BEGIN
    Dispose(Bloc);
    IF Number>0
      THEN Close(File1);
    IF Line>0
    THEN Write('Ligne ',Line,': ');
    WriteLn(Info);
    WriteLn('SC9 -> FM9 conversion abandonne...');
    Halt;
  END;


 PROCEDURE Error2(Number:Byte; Info:String);
  BEGIN
    Dispose(Bloc);
    IF Number>0
      THEN Close(File2);
    WriteLn(Info);
    WriteLn('SC9 -> FM9 conversion abandonne...');
    Halt;
  END;


 PROCEDURE Initializations;
  BEGIN
    WriteLn('SC9enFM9 v1.0 [SC9->FM9] - P.Ruelle/GRYPHAEA 94');
    New(bloc);
  END;


 PROCEDURE Load_SBI(Instname:String8; VAR Instrument:SBIFormat);
  VAR
    Instfile :File;
    Instname2:String;
    Nothing  :Array[1..36] Of Byte;
  BEGIN
    Instname2:=Instname+'.SBI';
    Assign(Instfile,Instname2);
    {$I-}
    Reset(Instfile,1);
    {$I+}
    IF ((IOResult<>0) OR (FileSize(Instfile)>52)) THEN
     Error1(7,'Fichier instrumental '+Instname2+' absent ou incorrect',cnt+6);
    BlockRead(Instfile,Nothing,36);
    BlockRead(Instfile,Instrument,11);
    Close(Instfile);
  END;


 PROCEDURE Read_SC9;
  VAR
    I,J        :Word;
    C_Line     :Word;
    C_Len      :Word;
    Lin_Notes  :Word;
    Qty_Notes,
    K,L        :Byte;
    Instrument,
    Volume,
    Octave,
    Note,
    Group      :Byte;
    Duration   :Word;
  BEGIN
    WriteLn;
    WriteLn('Lecture du script  ',Filename1,'...');
    Assign(File1,Filename1);
    {$I-}
    Reset(File1);
    {$I+}
    IF IOResult<>0
      THEN Error1(0,'Fichier script non trouv',0);

    {LECTURE DE L'ENTETE DU SCRIPT SC9}

    {Signature SC9}
    {$I-}
    ReadLn(File1,Chain);
    {$I+}
    IF IOResult<>0
      THEN Error1(1,Ffi,1);
    Len:=Length(Chain);
    IF NOT((Len=3) AND (Chain='SC9'))
      THEN Error1(1,'signature SC9 non trouve',1);

    {Titre}
    {$I-}
    ReadLn(File1,Chain);
    {$I+}
    IF IOResult<>0
      THEN Error1(1,Ffi,2);
    Len:=Length(Chain);
    Title:=Chain;
    IF Len<32
    THEN FOR I:=Len+1 TO 32 DO
           Title[I]:=' ';

    {Message}
    {$I-}
    ReadLn(File1,Chain);
    {$I+}
    IF IOResult<>0
      THEN Error1(1,Ffi,3);
    Len:=Length(Chain);
    Message:=Chain;
    IF Len<64
    THEN FOR I:=Len+1 TO 64 DO
           Message[I]:=' ';

    {Nombre d'Instruments}
    {$I-}
    ReadLn(File1,Chain);
    {$I+}
    IF IOResult<>0
      THEN Error1(2,Ffi,4);
    Len:=Length(Chain);
    IF Len<>8
      THEN Error1(2,'Dfinition d''instruments incorrecte',4);
    Aux:=Copy(Chain,6,3);
    Val(Aux,Nber_Inst,ce);
    IF ((Nber_Inst<1) OR (Nber_Inst>64))
      THEN Error1(3,'Nombre d''instruments incorrect',4);

    {Nombre de Voix}
    {$I-}
    ReadLn(File1,Chain);
    {$I+}
    IF IOResult<>0
      THEN Error1(4,Ffi,5);
    Len:=Length(Chain);
    IF Len<>6
      THEN Error1(4,'Dfinition des voix incorrecte',5);
    Aux:=Copy(Chain,6,1);
    Val(Aux,Nber_Voic,ce);
    IF Nber_Voic=0
      THEN Error1(5,'Nombre de voix incorrect',5);

    {Nombre de Ticks}
    {$I-}
    ReadLn(File1,Chain);
    {$I+}
    IF IOresult<>0
      THEN Error1(6,Ffi,6);
    Len:=Length(Chain);
    IF Len<>8
      THEN Error1(6,'Dfinition des ticks incorrecte',6);
    Aux:=Copy(Chain,6,3);
    Val(Aux,Nber_Tick,ce);
    IF ((Nber_Tick<20) OR (Nber_Tick>255))
      THEN Error1(6,'Nombre de ticks incorrect',6);

    {Instruments}
    FOR cnt:=1 TO Nber_Inst DO
      BEGIN
       {$I-}
       ReadLn(File1,Chain);
       {$I+}
       IF IOResult<>0
         THEN Error1(8,Ffi,cnt+6);
       Len:=Length(Chain);
       IF Len>8
         THEN Error1(8,'Nom d''instrument trop long',cnt+6);
       L_Names[cnt]:=Chain;
       IF Len<8
         THEN FOR I:=Len+1 TO 8 DO
                L_Names[cnt][I]:=' ';
       Load_SBI(L_Names[cnt],L_Inst[cnt]);
      END;

    {TRAITEMENT DES VOIX}
    Next_Elem:=1;
    C_Line:=Nber_Inst+6;
    FOR I:=1 TO Nber_Voic DO
      Total_Ticks[I]:=0;
    FOR I:=1 TO Nber_Voic DO
      BEGIN

        {Taille d'une Voix}
        Inc(C_Line);
        {$I-}
        ReadLn(File1,Chain);
        {$I+}
        IF IOResult<>0
          THEN Error1(9,Ffi,C_Line);
        Len:=Length(Chain);
        IF Len>5
          THEN Error1(9,'Dfinition de voix incorrecte',C_Line);
        Val(Chain,C_Len,ce);
        IF C_Len=0
          THEN Error1(10,'Taille de voix incorrecte',C_Line);
        C_Len:=C_Len*5;
        IF ((C_Len+Next_Elem+1)>65018)
          THEN Error1(11,'Taille de voix trop grande',C_Line);
        Bloc^[Next_Elem]:=Hi(C_Len);
        Inc(Next_Elem);
        Bloc^[Next_Elem]:=Lo(C_Len);
        Inc(Next_Elem);
        E_Voic[I]:=C_Len Div 5;

        {Traitement des notes d'une voix donne}
        Lin_Notes:=((C_Len Div 5)+3) Div 4;
        Nber_Event:=0;
        FOR J:=1 TO Lin_Notes DO
          BEGIN
            Inc(C_Line);
            {$I-}
            ReadLn(File1,Chain);
            {$I+}
            IF IOResult<>0
              THEN Error1(12,Ffi,C_Line);
            Len:=Length(Chain);
            IF ((Len<>19) AND (Len<>38) AND (Len<>57) AND
                (Len<>76))
              THEN Error1(12,'Ligne d''vnements incorrecte',C_Line);
            Qty_Notes:=Len Div 19;
            FOR K:=1 TO Qty_Notes DO
              BEGIN
                Inc(Nber_Event);

                {Evnement individuel d'une ligne}
                Aux:=Copy(Chain,(K-1)*19+1,19);

                {Extraction Instrument}
                Aux2:=Copy(Aux,1,3);
                Val(Aux2,Instrument,ce);
                IF ((Instrument<1) OR (Instrument>Nber_Inst))
                  THEN Error1(13,'Instrument incorrect',C_Line);
                Bloc^[Next_Elem]:=Instrument;
                Inc(Next_Elem);

                {Extraction Volume}
                Aux2:=Copy(Aux,5,2);
                Val(Aux2,Volume,ce);
                IF Volume>63
                  THEN Error1(14,'Volume incorrect',C_Line);
                Bloc^[Next_Elem]:=Volume;
                Inc(Next_Elem);

                {Extraction du groupe Octave+Note}
                Aux2:=Copy(Aux,8,1);
                Val(Aux2,Octave,ce);
                IF Octave>7
                  THEN Error1(15,'Octave incorrect',C_Line);
                Aux2:=Copy(Aux,10,4);

                {Notes converties en majuscules}
                FOR L:=1 TO 4 DO
                  Aux2[L]:=UpCase(Aux2[L]);
                Aux3:=Aux2;
                L:=0;
                Repeat
                  Inc(L);
                Until ((Aux3=L_Notes[L]) OR (L>35));
                IF L>35
                  THEN Error1(16,'Note incorrecte',C_Line);
                Note:=Code[L];
                Group:=(Octave SHL 4) OR Note;
                Bloc^[Next_Elem]:=Group;
                Inc(Next_Elem);

                {Extraction Dure}
                Aux2:=Copy(Aux,15,4);
                Val(Aux2,Duration,ce);
                IF ((Duration>9999) OR (Duration<1))
                  THEN Error1(17,'Dure incorrecte',C_Line);
                Bloc^[Next_Elem]:=Hi(Duration);
                Inc(Next_Elem);
                Bloc^[Next_Elem]:=Lo(Duration);
                Inc(Next_Elem);
                Total_Ticks[I]:=Total_Ticks[I]+Duration;
              END;
          END;
        IF E_Voic[I]<>Nber_Event
          THEN Error1(19,'Taille Voix <> Nombre d''vnements',C_Line);
      END;

    {Vrification des dures de toutes les voix}
    {Si elles sont gales alors OK sinon NOK!}
    IF Nber_Voic>1
    THEN BEGIN
           FOR I:=1 TO Nber_Voic-1 DO
             BEGIN
               IF Total_Ticks[I]<>Total_Ticks[I+1]
                 THEN Error1(18,'Dures des voix non gales',0);
             END;
         END;
    Close(File1);
  END;


 PROCEDURE Write_FM9;
  VAR
    I:Byte;
  BEGIN
    WriteLn('Ecriture du module ',Filename2,'...');
    Assign(File2,Filename2);
    {$I-}
    ReWrite(File2,1);
    {$I+}
    IF IOResult<>0
    THEN Error2(0,Efi);
    Chain:='FM9@';

    {Entte}
    {$I-}
    BlockWrite(File2,Chain[1],4); {FM9@}
    BlockWrite(File2,Title[1],32);
    BlockWrite(File2,Message[1],64);
    BlockWrite(File2,Nber_Inst,1);
    BlockWrite(File2,Nber_Voic,1);
    BlockWrite(File2,Nber_Tick,1);
    {$I+}
    IF IOResult<>0
      THEN Error2(1,Efi);

    {Instruments}
    FOR I:=1 TO Nber_Inst DO
      BEGIN
        {$I-}
        BlockWrite(File2,L_Names[I][1],8);
        BlockWrite(File2,L_Inst[I],11);
        {$I+}
        IF IOResult<>0
          THEN Error2(2,Efi);
      END;

    {Taille Voix & Evnements (pour chaque voix)}
    {$I-}
    BlockWrite(File2,Bloc^[1],Next_Elem-1);
    {$I+}
    IF IOResult<>0
      THEN Error2(3,Efi);

    Close(File2);
    Dispose(bloc);
    T_Exec:=Total_Ticks[1] Div Nber_Tick;
    E_Total:=0;
    FOR I:=1 TO Nber_Voic DO
      E_Total:=E_Total+E_Voic[I];
    WriteLn;
    WriteLn('Titre...: ',Title);
    WriteLn('Message.: ',Message);
    WriteLn;
    WriteLn('Nombre d''instruments......: ',Nber_Inst:5);
    WriteLn('Nombre de voix............: ',Nber_Voic:5);
    WriteLn('Ticks/s...................: ',Nber_Tick:5);
    FOR I:=1 TO Nber_Voic DO
    WriteLn('Evnements pour la voix ',I:1,'.: ',E_Voic[I]:5);
    WriteLn('Nombre total d''vnements.: ',E_Total:5);
    WriteLn('Dure du module...........: ',T_Exec Div 3600:2,':',
                                           (T_Exec Div 60 Mod 60):2,':',
                                           (T_Exec Div 1 Mod 60):2,'s');
  END;



 BEGIN
   ClrScr;
   Read_Params;
   Initializations;
   Read_SC9;
   Write_FM9;
 END.