PROGRAM PLAYER;


USES
 Digital;


TYPE
 String4 =String[4];
 String20=String[20];


CONST
 MaxDevices   =5;
 DeviceCommand:ARRAY[1..MaxDevices] OF String4 =
                    ('-L1','-L2','-S','-A','-SB');
 DeviceName   :ARRAY[1..MaxDevices] OF String20=
                    ('DAC sur LPT1',
                     'DAC sur LPT2',
                     'PC Speaker',
                     'FM AdLib',
                     'DAC SoundBlaster');


VAR
 i          :BYTE;
 Tval       :WORD;
 OutDevice  :DeviceType;
 NoFilter   :BOOLEAN;
 AdLib_OK,
 SB_OK,
 Mixer_OK   :BOOLEAN;
 Volume     :BYTE;
 SampleRate :WORD;
 SizeOfDigit:LongInt;
 SampleName :STRING;


FUNCTION UpString(StringIn:STRING):STRING;
VAR
 TempString:STRING;
 Counter   :BYTE;
BEGIN
  TempString:='';
  FOR Counter:=1 TO Length(StringIn) DO
    TempString:=TempString+UpCase(StringIn[Counter]);
  UpString:=TempString;
END;


PROCEDURE Intro;
BEGIN
  WriteLn;
  WriteLn('   PLAYER:  [DOMAINE PUBLIC]                                               ͻ');
  WriteLn('   programm par: Patrick Ruelle/43, av. de Grande Bretagne/98000 Monaco   ͼ');
  WriteLn;
END;


PROCEDURE Info;
BEGIN
  WriteLn(' Nom fichier.....: ',SampleName);
  WriteLn(' Taille fichier..: ',SizeOfDigit DIV 1024,'Ko');
  WriteLn(' Type sortie.....: ',DeviceName[Ord(OutDevice)+1]);
  WriteLn(' Frquence.......: ',SampleRate,'Hz');
  WriteLn(' Taille tampon...: 2 x ',BufSize Div 1000,'Ko');
  Write  (' Taille entte...: ',HeaSize,' octet');
  IF HeaSize<>1 THEN WriteLn('s') ELSE WriteLn;
  IF Mixer_OK THEN
  BEGIN
    Write(' Filtre passe-bas: ');
    IF NOT(NoFilter) THEN
      WriteLn('OFF')
    ELSE
      WriteLn('ON');
    WriteLn(' Volume..........: ',Volume,'/',VolMax);
  END;
END;


FUNCTION FileExists(FileName:STRING):BOOLEAN;
VAR F:FILE;
BEGIN
  SizeOfDigit:=0;
  {$I-}
  Assign(F,FileName);
  Reset(F,1);
  SizeOfDigit:=FileSize(F);
  Close(F);
  {$I+}
  FileExists:=(IOResult=0) AND (FileName<>'');
END;


PROCEDURE DelayT(Duration:BYTE);
VAR
 Count,Tick:WORD;
 Clock     :WORD ABSOLUTE $0000:$046C;
BEGIN
  Count:=0;
  REPEAT
    Tick:=Clock;
    REPEAT UNTIL Tick<>Clock;
    Inc(Count);
  UNTIL Count>=Duration;
END;


PROCEDURE WaitKey;ASSEMBLER;
ASM
  mov   ah, 00h
  int   16h
END;


FUNCTION FindOutPutDevice:DeviceType;
VAR
 Counter      :BYTE;
 DeviceCounter:BYTE;
 Found        :BOOLEAN;
 Device       :DeviceType;
BEGIN
  Counter:=1;
  Found  :=False;
  Device :=PcSpeaker;
  WHILE (Counter<=ParamCount) AND NOT(Found) DO
  BEGIN
    FOR DeviceCounter:=1 TO MaxDevices DO
      IF UpString(ParamStr(Counter))=DeviceCommand[DeviceCounter] THEN
      BEGIN
        Device:=DeviceType(DeviceCounter-1);
        Found :=True;
      END;
    Inc(Counter);
  END;
  FindOutPutDevice:=Device;
END;


FUNCTION FindRawFileName:STRING;
VAR
 FileNameFound:STRING;
 TempName     :STRING;
 Found        :BOOLEAN;
 Counter      :BYTE;
BEGIN
  FileNameFound:='';
  Counter      :=1;
  Found        :=False;
  WHILE (Counter<=ParamCount) AND NOT(Found) DO
  BEGIN
    TempName:=UpString(ParamStr(Counter));
    IF TempName[1]<>'-' THEN
    BEGIN
      FileNameFound:=TempName;
      Found        :=True;
    END;
    Inc(Counter);
  END;
  FindRawFileName:=FileNameFound;
END;


FUNCTION FindPlayBackRate:WORD;
VAR
 RateString:STRING;
 Rate      :WORD;
 Found     :BOOLEAN;
 Counter   :BYTE;
 ErrorCode :INTEGER;
BEGIN
  Rate   :=11000;
  Counter:=1;
  Found  :=False;
  WHILE (Counter<=ParamCount) AND NOT(Found) DO
  BEGIN
    RateString:=UpString(ParamStr(Counter));
    IF Copy(RateString,1,2)='-F' THEN
    BEGIN
      RateString:=Copy(RateString,3,Length(RateString)-2);
      Val(RateString,Rate,ErrorCode);
      IF ErrorCode<>0 THEN
      BEGIN
        Rate:=11000;
        IF NOT(TextBool) THEN WriteLn(' Frquenc incorrecte, dfaut utilis');
      END;
      Found:=True;
    END;
    Inc(Counter);
  END;
  IF Rate<4000 THEN
    Rate:=4000
  ELSE
    IF Rate>22000 THEN
      Rate:=22000;
  FindPlayBackRate:=Rate;
END;


FUNCTION FindBufferSize:WORD;
VAR
 BufferString:STRING;
 Buffer      :WORD;
 Found       :BOOLEAN;
 Counter     :BYTE;
 ErrorCode   :INTEGER;
BEGIN
  Buffer :=16;
  Counter:=1;
  Found  :=False;
  WHILE (Counter<=ParamCount) AND NOT(Found) DO
  BEGIN
    BufferString:=UpString(ParamStr(Counter));
    IF Copy(BufferString,1,2)='-T' THEN
    BEGIN
      BufferString:=Copy(BufferString,3,Length(BufferString)-2);
      Val(BufferString,Buffer,ErrorCode);
      IF ErrorCode<>0 THEN
      BEGIN
        Buffer:=16;
        IF NOT(TextBool) THEN WriteLn(' Tampon incorrect, dfaut utilis');
      END;
      Found:=True;
    END;
    Inc(Counter);
  END;
  IF Buffer<8 THEN
    Buffer:=8
  ELSE
    IF Buffer>64 THEN
      Buffer:=64;
  FindBufferSize:=Buffer*1000;
END;


FUNCTION FindXMS:BOOLEAN;
VAR
 XMSString :STRING;
 Found     :BOOLEAN;
 Counter   :BYTE;
BEGIN
  IF NoXMS
    THEN UseXMS:=False;
  Counter:=1;
  Found  :=False;
  WHILE (Counter<=ParamCount) AND NOT(Found) DO
  BEGIN
    XMSString:=UpString(ParamStr(Counter));
    IF Copy(XMSString,1,2)='-X' THEN
      Found:=True;
    Inc(Counter);
  END;
  FindXMS:=Found;
END;


FUNCTION FindHeaderSize:WORD;
VAR
 HeaderString:STRING;
 Header      :WORD;
 Found       :BOOLEAN;
 Counter     :BYTE;
 ErrorCode   :INTEGER;
BEGIN
  Header :=0;
  Counter:=1;
  Found  :=False;
  WHILE (Counter<=ParamCount) AND NOT(Found) DO
  BEGIN
    HeaderString:=UpString(ParamStr(Counter));
    IF Copy(HeaderString,1,2)='-E' THEN
    BEGIN
      HeaderString:=Copy(HeaderString,3,Length(HeaderString)-2);
      Val(HeaderString,Header,ErrorCode);
      IF ErrorCode<>0 THEN
      BEGIN
        Header:=0;
        IF NOT(TextBool) THEN WriteLn(' Entte incorrect, dfaut utilis');
      END;
      Found:=True;
    END;
    Inc(Counter);
  END;
  IF Header<0 THEN
    Header:=0
  ELSE
    IF Header>255 THEN
      Header:=255;
  FindHeaderSize:=Header;
END;


FUNCTION FindTextBool:BOOLEAN;
VAR
 TexterString:STRING;
 Found       :BOOLEAN;
 Counter     :BYTE;
BEGIN
  Counter:=1;
  Found  :=False;
  WHILE (Counter<=ParamCount) AND NOT(Found) DO
  BEGIN
    TexterString:=UpString(ParamStr(Counter));
    IF Copy(TexterString,1,2)='-R' THEN
      Found:=True;
    Inc(Counter);
  END;
  FindTextBool:=Found;
END;


FUNCTION FindFilter:BOOLEAN;
VAR
 FilterString:STRING;
 Found       :BOOLEAN;
 Counter     :BYTE;
BEGIN
  Counter:=1;
  Found  :=False;
  WHILE (Counter<=ParamCount) AND NOT(Found) DO
  BEGIN
    FilterString:=UpString(ParamStr(Counter));
    IF Copy(FilterString,1,2)='-B' THEN
      Found:=True;
    Inc(Counter);
  END;
  FindFilter:=Found;
END;


FUNCTION FindVolume:WORD;
VAR
 VolumeString:STRING;
 Vol         :WORD;
 Found       :BOOLEAN;
 Counter     :BYTE;
 ErrorCode   :INTEGER;
BEGIN
  Vol    :=9;
  Counter:=1;
  Found  :=False;
  WHILE (Counter<=ParamCount) AND NOT(Found) DO
  BEGIN
    VolumeString:=UpString(ParamStr(Counter));
    IF Copy(VolumeString,1,2)='-V' THEN
    BEGIN
      VolumeString:=Copy(VolumeString,3,Length(VolumeString)-2);
      Val(VolumeString,Vol,ErrorCode);
      IF ErrorCode<>0 THEN
      BEGIN
        Vol:=9;
        IF NOT(TextBool) THEN WriteLn(' Volume incorrect, dfaut utilis');
      END;
      Found:=True;
    END;
    Inc(Counter);
  END;
  IF Vol<1 THEN
    Vol:=1
  ELSE
    IF Vol>VolMax THEN
      Vol:=VolMax;
  FindVolume:=Vol;
END;


PROCEDURE Buffer_Test;
VAR
 MemSize:LongInt;
 OneBuf :WORD;
BEGIN
  MemSize:=MaxAvail;
  IF MemSize<(2*BufSize) THEN
  BEGIN
    OneBuf:=((MemSize DIV 1000)*1000) DIV 2;
    IF OneBuf<8000 THEN
    BEGIN
      IF NOT(TextBool) THEN
      BEGIN
        WriteLn(' Mmoire insuffisante.');
        DelayT(19);
        Video_03h;
        Halt;
      END;
    END
    ELSE BufSize:=OneBuf;
  END;
END;


PROCEDURE Adlister_Test;
BEGIN
  WriteLn;
  Write(' Puce FM AdLib...: ');
  IF AdLib_OK THEN
    WriteLn('Dtecte [388h]')
  ELSE
    WriteLn('Non dtecte');
  Write(' DAC SoundBlaster: ');
  IF SB_OK THEN
    WriteLn('Dtect [',Hexa_Addr(SBPort):3,'h]')
  ELSE WriteLn('Non dtect');
  Write(' Puce Mixer......: ');
  IF Mixer_OK THEN WriteLn('Dtecte')
  ELSE WriteLn('Non dtecte');
  Write(' Carte dtecte..: ');
  CASE CardType OF
    Speaker:WriteLn('Aucune (PC SPEAKER)');
    AdLibFM:WriteLn('ADLIB');
    SB_Norm:WriteLn('SOUNDBLASTER');
    SB_Pro :WriteLn('SOUNDBLASTER PRO');
    SB_16  :WriteLn('SOUNDBLASTER 16');
  END;
  WriteLn;
END;


PROCEDURE Device_Selection;
BEGIN
  CASE OutDevice OF
   SoundBlaster:BEGIN
                  IF SB_OK=False THEN
                  BEGIN
                    IF AdLib_OK=False THEN
                      OutDevice:=PCSpeaker
                    ELSE OutDevice:=AdLib;
                  END;
                END;
   AdLib       :BEGIN
                  IF AdLib_OK=False THEN
                    OutDevice:=PCSpeaker;
                END;
  END;
END;


PROCEDURE Init_Device;
BEGIN
  CASE OutDevice OF
   PCSpeaker   :BEGIN
                  Tval:=(1193180 DIV SampleRate) SHR 1;
                  FOR i:=0 TO 255 DO
                    SpkrTable[i]:=(WORD((SpkrBaseTable[i]-1)*Tval) DIV $39)+1;
                  Init_Speaker;
                END;
   AdLib       :BEGIN
                  InitializeAdLib;
                END;
   SoundBlaster:BEGIN
                  Spk_On;
                END;
  END;
END;


PROCEDURE Deinit_Device;
BEGIN
  CASE OutDevice OF
   PCSpeaker   :End_Speaker;
   SoundBlaster:Spk_Off;
  END;
END;


BEGIN
  IF ParamCount<>0 THEN
  BEGIN
    NoFilter  :=True;
    Volume    :=9;
    TextBool  :=FindTextBool;
    IF NOT(TextBool) THEN
    BEGIN
      Video_12h;
      LCD_Font;
    END;
    IF NOT(TextBool) THEN Intro;
    XMSChoice :=FindXMS;
    SampleRate:=FindPlayBackRate;
    BufSize   :=FindBufferSize;
    HeaSize   :=FindHeaderSize;
    NoFilter  :=FindFilter;
    SampleName:=FindRawFileName;
    OutDevice :=FindOutPutDevice;
    AdLib_OK  :=AdLib_Test;
    SB_OK     :=SB_Test;
    Mixer_OK  :=Mixer_Test;
    Volume    :=FindVolume;
    Buffer_Test;
    IF NOT(TextBool) THEN Adlister_Test;
    Device_Selection;
    IF SampleName<>'' THEN
    BEGIN
      IF FileExists(SampleName) THEN
      BEGIN
        IF SizeOfDigit>999 THEN
        BEGIN
          IF NOT(TextBool) THEN Info;
          Init_Device;
          SetOutputDevice(OutDevice);
          IF Mixer_OK THEN
          BEGIN
            IF NOT(NoFilter) THEN
              SbProSetFilter(True)
            ELSE
              SbProSetFilter(False);
            VoiceMixerVol(Volume);
          END;
          Disable_Keyboard;
          IF NOT(TextBool) THEN OscilloScr;
          IF UseXMS THEN
          BEGIN
            IF XMSChoice THEN
            BEGIN
             LoadPlayXMS(SampleName,SampleRate);
             IF XMSError<>0 THEN
               PlayRAWSoundFile(SampleName,SampleRate);
            END
            ELSE PlayRAWSoundFile(SampleName,SampleRate);
          END
          ELSE
          BEGIN
            IF XMSChoice THEN
            BEGIN
              IF NOT(TextBool) THEN WriteLn(' Driver XMS non dtect.');
            END;
            PlayRAWSoundFile(SampleName,SampleRate);
          END;
          Enable_Keyboard;
          IF Mixer_OK THEN
            VoiceMixerVol(9);
          Deinit_Device;
        END
        ELSE
        BEGIN
          IF NOT(TextBool) THEN WriteLn(' Fichier trop petit.');
        END;
      END
      ELSE
      BEGIN
        IF NOT(TextBool) THEN WriteLn(' Fichier inexistant.');
      END;
    END
    ELSE
    BEGIN
      IF NOT(TextBool) THEN WriteLn(' Fichier non prcis.');
    END;
    CleanUp;
    IF NOT(TextBool) THEN
    BEGIN
      DelayT(19);
      Video_03h;
    END;
  END
  ELSE
  BEGIN
    Video_12h;
    LCD_Font;
    Intro;
    WriteLn(' ͻ');
    WriteLn('  USAGE...: PLAYER [OPTIONS] <FICHIER SON BRUT>      Patrick Ruelle (C) 1994 ');
    WriteLn(' Ķ');
    WriteLn('         PC_Speaker - AdLib - LPT1 - LPT2 - SB - SB_PRO - SB_16       ');
    WriteLn(' Ķ');
    WriteLn('  OPTIONS: [DOMAINE PUBLIC]                                                  ');
    WriteLn('   -S       PC Speaker (dfaul)           -Fxxxxx  de 4000Hz  22000Hz       ');
    WriteLn('   -L1      DAC sur LPT1                  -Txx     de    8Ko     64Ko       ');
    WriteLn('   -L2      DAC sur LPT2                  -Exxx    de    0      255 octets  ');
    WriteLn('   -A       FM AdLib                      -Vxx     de    1      [15 ou 31]  ');
    WriteLn('   -SB      DAC SoundBlaster              -B       Filtre passe-Bas          ');
    WriteLn('   -X       XMS (sinon disque continu)    -R       Rien  l''cran            ');
    WriteLn(' Ķ');
    WriteLn('   -F  Frquence (dfaut=11000Hz)         -T  Taille Tampon (dfaut=16Ko)    ');
    WriteLn('   -E  Entte  sauter (dfaut=0)         -V  Volume de sortie (dfaut=9)    ');
    WriteLn(' ͼ');
    WaitKey;
    Video_03h;
  END;
END.