{$R-,V-,A+}
PROGRAM DigiPlay;

USES
 Crt,uSB_Spkr;

VAR
 TailleDigit:LongInt;
 NomFichier :STRING;
 TamponSon  :PointeurMem;
 Cptr       :WORD;


{=[Convertit une Chaine en Majuscules]======================================}

FUNCTION Majuscules(ChaineIn:STRING):STRING;
VAR
 ChaineTemp:STRING;
 Compteur  :BYTE;
BEGIN
  ChaineTemp:='';
  FOR Compteur:=1 TO Length(ChaineIn) DO
    ChaineTemp:=ChaineTemp+UpCase(ChaineIn[Compteur]);
  Majuscules:=ChaineTemp;
END;


{=[Verifie l'Existence et la Validite du Fichier]===========================}

FUNCTION Fichier_Existe(NomFichier:STRING):BOOLEAN;
VAR F:FILE;
BEGIN
  TailleDigit:=0;
  {$I-}
  Assign(F,NomFichier);
  Reset (F,1);
  TailleDigit :=FileSize(F);
  TailleTampon:=TailleDigit;
  Close (F);
  {$I+}
  Fichier_Existe:=(IOResult=0) AND (TailleDigit<65000) AND
                  (TailleDigit>1000) AND (MaxAvail>=TailleDigit);
END;


{=[Extraction des Parametres de la Ligne de Commande]=======================}

FUNCTION Cherche_NomFichier:STRING;
VAR
 NomFichierTrouve:STRING;
 NomTemp         :STRING;
 Trouve          :BOOLEAN;
 Compteur        :BYTE;
BEGIN
  NomFichierTrouve:='';
  Compteur        :=1;
  Trouve          :=False;
  WHILE (Compteur<=ParamCount) AND NOT(Trouve) DO
  BEGIN
    NomTemp:=Majuscules(ParamStr(Compteur));
    IF NomTemp[1]<>'/' THEN
    BEGIN
      NomFichierTrouve:=NomTemp;
      Trouve          :=True;
    END;
    Inc(Compteur);
  END;
  Cherche_NomFichier:=NomFichierTrouve;
END;


FUNCTION Cherche_Frequence:WORD;
VAR
 ChaineFrequence:STRING;
 Frequence      :WORD;
 Trouve         :BOOLEAN;
 Compteur       :BYTE;
 CodeErreur     :INTEGER;
BEGIN
  Frequence:=11000;
  Compteur :=1;
  Trouve   :=False;
  WHILE (Compteur<=ParamCount) AND NOT(Trouve) DO
  BEGIN
    ChaineFrequence:=Majuscules(ParamStr(Compteur));
    IF Copy(ChaineFrequence,1,2)='/F' THEN
    BEGIN
      ChaineFrequence:=Copy(ChaineFrequence,3,Length(ChaineFrequence)-2);
      Val(ChaineFrequence,Frequence,CodeErreur);
      IF CodeErreur<>0 THEN
      BEGIN
        Frequence:=11000;
        WriteLn('Frquence incorrecte, valeur par dfaut: 11000Hz');
      END;
      Trouve:=True;
    END;
    Inc(Compteur);
  END;
  IF Frequence<4000 THEN
    Frequence:=4000
  ELSE
    IF Frequence>22000 THEN
      Frequence:=22000;
  Cherche_Frequence:=Frequence;
END;


{=[LES Routines Finales avec Toutes les Precautions]========================}

PROCEDURE Joue_Digit(NomFichier:STRING;Frequence:WORD);
BEGIN
  Initialise_Routine;
  GetMem(TamponSon,TailleTampon);
  Joue_Son_Digital(NomFichier,Frequence,TamponSon);
END;

PROCEDURE Fin_Digit;
BEGIN
  Restaure_Routine;
  FreeMem(TamponSon,TailleTampon);
END;

{=[PROGRAMME PRINCIPAL]=====================================================}

BEGIN
  ClrScr;
  IF ParamCount<>0 THEN
  BEGIN
    Frequence :=Cherche_Frequence;
    NomFichier:=Cherche_NomFichier;
    IF NomFichier<>'' THEN
    BEGIN
      IF Fichier_Existe(NomFichier) THEN
      BEGIN
        GoToXY(1,1);
        WriteLn('Echantillon en arrire-plan...');
        JOUE_DIGIT(NOMFICHIER,FREQUENCE);
        Cptr:=0; {A PARTIR D'ICI ON EST EN ARRIERE-PLAN!}
        REPEAT
          GoToXY(1,2);
          Write('Compteur en avant-plan........ ',Cptr:5);
          Inc(Cptr);
        UNTIL SonFini;
        FIN_DIGIT; {ET D'ICI A NOUVEAU EN AVANT-PLAN...}
        WriteLn;
      END
      ELSE
        WriteLn('Problme fichier (Non Trouv|Trop Grand|Peu de Mmoire).');
    END
    ELSE
      WriteLn('Nom de fichier absent.');
  END
  ELSE
  BEGIN
    WriteLn;
    WriteLn(' Utilisation: DigiPlay [/Fxxxxx] NomFichier');
    WriteLn;
    WriteLn(' avec   /Fxxxxx de 4000  22000Hz (11000 par dfaut)');
    WriteLn('   et   1000<Taille(NomFichier)<65000 octets');
  END;
END.