UNIT uSB_Spkr;

INTERFACE


{=[Constantes et Variables de l'Interface]==================================}

CONST
 TableBase:ARRAY[0..255] OF BYTE=
        ($40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$3F,$3F,$3F,$3F,$3F,$3F,
         $3F,$3F,$3F,$3F,$3F,$3F,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,
         $3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3C,$3C,$3C,$3C,$3C,$3C,$3C,
         $3C,$3C,$3C,$3B,$3B,$3B,$3B,$3B,$3B,$3B,$3B,$3B,$3B,$3A,$3A,$3A,
         $3A,$3A,$3A,$3A,$3A,$3A,$3A,$39,$39,$39,$39,$39,$39,$39,$39,$39,
         $39,$38,$38,$38,$38,$38,$38,$38,$38,$37,$37,$37,$37,$37,$36,$36,
         $36,$36,$35,$35,$35,$35,$34,$34,$34,$33,$33,$32,$32,$31,$31,$30,
         $30,$2F,$2E,$2D,$2C,$2B,$2A,$29,$28,$27,$26,$25,$24,$23,$22,$21,
         $20,$1F,$1E,$1D,$1C,$1B,$1A,$19,$18,$17,$16,$15,$14,$13,$12,$11,
         $11,$10,$10,$0F,$0F,$0E,$0E,$0D,$0D,$0D,$0C,$0C,$0C,$0C,$0B,$0B,
         $0B,$0B,$0A,$0A,$0A,$0A,$0A,$09,$09,$09,$09,$09,$09,$09,$09,$09,
         $08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$07,$07,$07,$07,
         $07,$07,$07,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$05,$05,
         $05,$05,$05,$05,$05,$05,$05,$05,$04,$04,$04,$04,$04,$04,$04,$04,
         $04,$04,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$02,$02,$02,$02,
         $02,$02,$02,$02,$02,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01);

TYPE
 TypeTampon =ARRAY[0..0] OF BYTE;
 PointeurMem=^TypeTampon;

VAR
 SonFini     :BOOLEAN;
 Frequence   :WORD;
 TailleTampon:WORD;


{=[Procedures de l'Interface]===============================================}

PROCEDURE Initialise_Routine;
PROCEDURE Restaure_Routine;
PROCEDURE Joue_Son_Digital(NomFichier:STRING;Frequence:WORD;
                           VAR TamponD:PointeurMem);


{=[Constantes et Variables de l'Unite]======================================}

IMPLEMENTATION

VAR
 Aux          :BYTE;
 TailleDonnees:WORD;
 Tampon       :PointeurMem;
 AncienINT8   :Pointer;
 VecteurINT   :ARRAY[0..255] OF Pointer ABSOLUTE $0000:$0000;
 SB_OK        :BOOLEAN;
 TableSpeaker :ARRAY[0..255] OF BYTE;
 PortSB       :WORD;
 ValeurTimer  :WORD;
 Var1         :BYTE;


{=[Initialisation et Restauration SoundBlaster/Speaker]=====================}

FUNCTION Detecte_SoundBlaster:BOOLEAN;
CONST
 Tempo1=10; {Augmenter les valeurs de Tempo1 et Tempo2 si la dtection}
 Tempo2=50; {pose quelques problmes...                               }
VAR
 Trouve    :BOOLEAN;
 Compteur1,
 Compteur2 :WORD;
BEGIN
  PortSB              :=$210;
  Trouve              :=False;
  Compteur1           :=Tempo1;
  Detecte_SoundBlaster:=False;
  WHILE (PortSB<=$260) AND NOT Trouve DO
  BEGIN
    Port[PortSB+$6]:=1;
    Port[PortSB+$6]:=0;
    Compteur2      :=Tempo2;
    WHILE (Compteur2>0) AND (Port[PortSB+$E]<128) DO
      Dec(Compteur2);
    IF (Compteur2=0) OR (Port[PortSB+$A]<>$AA) THEN
    BEGIN
      Dec(Compteur1);
      IF (Compteur1=0) THEN
      BEGIN
        Compteur1:=Tempo1;
        PortSB   :=PortSB+$10;
      END
    END
    ELSE Trouve:=True;
  END;
  IF Trouve THEN
    Detecte_SoundBlaster:=True;
END;


PROCEDURE SB_On;
BEGIN
  REPEAT UNTIL Port[PortSB+$C]<$80;
  Port[PortSB+$C]:=$D1;
END;


PROCEDURE SB_Off;
BEGIN
  REPEAT UNTIL Port[PortSB+$C]<$80;
  Port[PortSB+$C]:=$D3;
END;


PROCEDURE Initialise_Speaker;
BEGIN
  Port[$61]:=Port[$61] OR 3;
  Port[$43]:=$B6;
  Port[$43]:=$B0;
  Port[$43]:=$34;
  Port[$42]:=$00;
  Port[$42]:=$00;
  Port[$43]:=$90;
END;


PROCEDURE Restaure_Speaker;
BEGIN
  Port[$61]:=Port[$61] AND $FC;
END;


{=[LES Routines Appelees xxxxx fois par le Timer!]==========================}

PROCEDURE Joue_Sur_SoundBlaster;Interrupt;
CONST
 CompteurT:WORD=0;
BEGIN
  IF NOT(SonFini) THEN
  BEGIN
    IF CompteurT<=TailleDonnees THEN
    BEGIN
      Aux:=Tampon^[CompteurT];
      Port[PortSB+$C]:=$10;
      REPEAT UNTIL Port[PortSB+$C]<$80;
      Port[PortSB+$C]:=Aux;
      Inc(CompteurT);
    END
    ELSE
    BEGIN
      SonFini  :=True;
      CompteurT:=0;
    END;
  END;
  Port[$20]:=$20;
END;


PROCEDURE Joue_Sur_Speaker;Interrupt;
CONST
 CompteurT:WORD=0;
BEGIN
  IF NOT(SonFini) THEN
  BEGIN
    IF CompteurT<=TailleDonnees THEN
    BEGIN
      Aux:=Tampon^[CompteurT];
      Port[$42]:=0;
      Port[$42]:=TableSpeaker[Aux];
      Inc(CompteurT);
    END
    ELSE
      SonFini  :=True;
  END;
  Port[$20]:=$20;
End;


{=[Routines de Traitement de la Puce Timer 8253]============================}

PROCEDURE Traite_8253(Valeur:WORD);
BEGIN
  Port[$43]:=54;
  Port[$40]:=Lo(Valeur);
  Port[$40]:=Hi(Valeur);
END;


PROCEDURE Choisit_Frequence(Frequence:WORD);
BEGIN
  Traite_8253(1193180 DIV Frequence);
END;


PROCEDURE Frequence_Initiale;
BEGIN
  Traite_8253(0);
END;


{=[Transfert des Donnees DISQUE-->RAM]======================================}

FUNCTION Charge_Tampon(VAR F:FILE;VAR TamponD:PointeurMem):WORD;
VAR
 OctetsLus:WORD;
BEGIN
  BlockRead(F,TamponD^,TailleTampon,OctetsLus);
  Charge_Tampon:=OctetsLus;
END;


{=[Initialisations Diverses]================================================}

PROCEDURE Active_Tampon(TamponPtr:PointeurMem;Taille:WORD);
BEGIN
  Tampon       :=TamponPtr;
  TailleDonnees:=Taille-1;
  SonFini      :=False;
END;


PROCEDURE Initialisations;
BEGIN
  SonFini   :=True;
  AncienINT8:=VecteurINT[$08];
  SB_OK     :=Detecte_SoundBlaster;
END;


PROCEDURE Initialise_Routine;
BEGIN
  InLine($FA);
  IF SB_OK THEN
  BEGIN
    VecteurINT[$08]:=@Joue_Sur_SoundBlaster;
    SB_On;
  END
  ELSE
  BEGIN
    ValeurTimer:=(1193180 DIV Frequence) SHR 1;
    FOR Var1:=0 TO 255 DO
      TableSpeaker[Var1]:=(WORD((TableBase[Var1]-1)*ValeurTimer) DIV $37)+1;
    VecteurINT[$08]:=@Joue_Sur_Speaker;
    Initialise_Speaker;
  END;
  InLine($FB);
END;


PROCEDURE Restaure_AncienINT8;
BEGIN
  InLine($FA);
  VecteurINT[$08]:=AncienINT8;
  InLine($FB);
END;


{=[LA Routine Globale Jouant une Sequence Digitale]=========================}

PROCEDURE Joue_Son_Digital(NomFichier:STRING;Frequence:WORD;
                           VAR TamponD:PointeurMem);
VAR
 Fichier:FILE;
 TailleS:WORD;
BEGIN
  Choisit_Frequence(Frequence);
  Assign(Fichier,NomFichier);
  Reset (Fichier,1);
  TailleS:=Charge_Tampon(Fichier,TamponD);
  Close(Fichier);
  Active_Tampon(TamponD,TailleS);
END;


{=[A ne pas Oublier Avant de Quitter le Programme!]=========================}

PROCEDURE Restaure_Routine;
BEGIN
  Frequence_Initiale;
  Restaure_AncienINT8;
  IF SB_OK THEN
    SB_Off
  ELSE
    Restaure_Speaker;
END;


{=[CORPS PRINCIPAL]=========================================================}

BEGIN
  Initialisations;
END.
