PROGRAM DigiRec;

USES
 Crt,DOS;

CONST
 MaxSauve   =290;

TYPE
 Tmp        =^Tableau;
 Tableau    =ARRAY[1..64999] OF BYTE;

VAR
 Ecran      :ARRAY [0..199,0..319] OF BYTE ABSOLUTE $A000:0000;
 Car        :Char;
 Suf,Nbre   :STRING;
 XLrg,XMax,
 YMax,XMil,
 YMil,HMax,
 XDeb,Fond,
 Blanc,Gris,
 GrisClair,
 GrisFonce  :INTEGER;
 Sauve      :ARRAY [0..MaxSauve] OF BYTE;
 PortSB     :WORD;
 x,y,Cptr,
 NouveauX   :WORD;
 YSauve     :BYTE;
 regs       :Registers;
 F          :FILE;
 NomFic     :STRING;
 Marche,
 Mixer      :BOOLEAN;
 Tampon     :Tmp;
 Taille     :WORD;
 AncienVect :Pointer;
 VecteurINT :ARRAY[0..255] OF Pointer ABSOLUTE $0000:$0000;


{=[Routine Puce Timer 8253]=================================================}

PROCEDURE Traite_8253(Valeur:WORD);
BEGIN
  Port[$43]:=54;
  Port[$40]:=Lo(Valeur);
  Port[$40]:=Hi(Valeur);
END;


{=[Routines graphiques]=====================================================}

PROCEDURE Initialise_13h;
BEGIN
  regs.AH:=$00;
  regs.AL:=$13;
  Intr($10,regs);
END;


PROCEDURE Affiche_Pixel(x,y:WORD;Coul:BYTE);
BEGIN
  Ecran[y,x]:=Coul;
END;


PROCEDURE Ligne_H(x1,y1,x2:WORD;Coul:BYTE);
BEGIN
  FillChar(Ecran[y1,x1],x2-x1,Coul);
END;


PROCEDURE Ligne_V(x1,y1,y2:WORD;Coul:BYTE);
VAR
 y:WORD;
BEGIN
  FOR y:=y1 TO y2 DO
    Ecran[y,x1]:=Coul;
END;


PROCEDURE Remplit_Carre(x1,y1,x2,y2:WORD;Coul:BYTE);
VAR
 y:WORD;
BEGIN
  FOR y:=y1 TO y2 DO
    Ligne_H(x1,y,x2,Coul);
END;


{=[L'enregistrement fonctionnant en arriere-plan]===========================}

PROCEDURE Enregistrement_De_SB;INTERRUPT;
CONST
 Fini:BOOLEAN=True;
BEGIN
  IF Fini THEN
  BEGIN
    Fini:=False;
    {ENREGISTREMENT A PARTIR DU MICRO}
    Port[PortSB+$0C]:=$20;
    REPEAT UNTIL Port[PortSB+$0E]>=$80;
    y:=Port[PortSB+$0A];
    IF Marche THEN
    BEGIN
      Tampon^[Taille]:=y;
      IF Taille>64998 THEN
        Marche:=False
      ELSE
        Inc(Taille);
    END;
    Fini:=True;
  END;
  Port[$20]:=$20;
END;


{=[Routines sonores]========================================================}

FUNCTION Detecte_SoundBlaster:BOOLEAN;
CONST
 Tempo1=10;
 Tempo2=50;
VAR
 Trouve    :BOOLEAN;
 Compteur1,
 Compteur2 :WORD;
BEGIN
  PortSB              :=$210;
  Trouve              :=False;
  Compteur1           :=Tempo1;
  Detecte_SoundBlaster:=False;
  WHILE (PortSB<=$260) AND NOT Trouve DO
  BEGIN
    Port[PortSB+$6]:=1;
    Port[PortSB+$6]:=0;
    Compteur2      :=Tempo2;
    WHILE (Compteur2>0) AND (Port[PortSB+$E]<128) DO
      Dec(Compteur2);
    IF (Compteur2=0) OR (Port[PortSB+$A]<>$AA) THEN
    BEGIN
      Dec(Compteur1);
      IF (Compteur1=0) THEN
      BEGIN
        Compteur1:=Tempo1;
        PortSB   :=PortSB+$10;
      END
    END
    ELSE Trouve:=True;
  END;
  IF Trouve THEN
    Detecte_SoundBlaster:=True;
END;


PROCEDURE SB_Off;
BEGIN
  REPEAT UNTIL Port[PortSB+$C]<$80;
  Port[PortSB+$C]:=$D3;
END;


PROCEDURE Ecrit_Mixer(Commande,Valeur:BYTE);
BEGIN
  Port[PortSB+$04]:=Commande;
  Port[PortSB+$05]:=Valeur;
END;


FUNCTION Lit_Mixer(Commande:BYTE):BYTE;
BEGIN
  Port[PortSB+$04]:=Commande;
  Lit_Mixer       :=Port[PortSB+$05];
END;


FUNCTION Test_Mixer:BOOLEAN;
BEGIN
  Ecrit_Mixer($00,$00); {REINITIALISE LA PUCE MIXER}
  Test_Mixer:=False;
  Ecrit_Mixer($22,$F3);
  IF Lit_Mixer($22)=$F3 THEN
  BEGIN
    Test_Mixer:=True;
    Ecrit_Mixer($22,$99);
  END;
END;


{=[Initialisations diverses]================================================}

FUNCTION Init_GraphSon:BOOLEAN;
VAR
 N:LONGINT;
BEGIN
  Init_GraphSon:=False;
  Initialise_13h;
  Car      :=#0;
  XMax     :=319;
  XMil     :=XMax DIV 2;
  YMax     :=199;
  YMil     :=YMax DIV 2;
  XLrg     :=290;
  XDeb     :=XMil-XLrg DIV 2;
  HMax     :=65;
  Gris     :=26;
  GrisClair:=31;
  GrisFonce:=21;
  Blanc    :=30;
  Fond     :=170;
  Remplit_Carre(XDeb-10,YMil-HMax-1-10,XDeb+XLrg+1+10,YMil+HMax+1+10,Gris);
  Remplit_Carre(XDeb,YMil-HMax-2,XDeb+XLrg+1,YMil+HMax+2,Fond);
  Ligne_H(XDeb-10,YMil-HMax-1-10,XDeb+XLrg+1+10,GrisClair);
  Ligne_H(XDeb-10,YMil+HMax+1+10,XDeb+XLrg+1+10,GrisFonce);
  Ligne_V(XDeb+XLrg+1+10,YMil-HMax-1-10,YMil+HMax+1+10,GrisClair);
  Ligne_V(XDeb-10,YMil-HMax-1-09,YMil+HMax+1+10,GrisFonce);
  FOR N:=0 TO MaxSauve DO
    Sauve[N]:=128; {SILENCES}
  IF Detecte_SoundBlaster THEN
  BEGIN
    Init_GraphSon:=True;
    Mixer:=Test_Mixer;
  END;
END;


PROCEDURE Initialisations;
BEGIN
  x:=0;
  Cptr:=0;
  New(Tampon);
  Marche:=False;
  DirectVideo:=False;
  Taille:=1;
  NomFic:='DIGI_REC';
  GoToXY(16,2); Write('DigiRec');
  GoToXY(1,24); Write('<M>arche <A>rrt <S>auver  <ESC>:Quitter');
  SB_Off;
  IF Mixer THEN
  BEGIN                             {DE 4KHz A 23KHz SUR SBPRO/SBPRO2}
    Traite_8253(1193180 DIV 16000); {ON CHOISIT 16KHz...}
    Ecrit_Mixer($0A,$07);           {VOLUME MICRO MAXI}
    Ecrit_Mixer($0C,$20);           {ENTREE ADC = MICRO SANS FILTRE}
  END
  ELSE                              {DE 4KHz A 13KHz SUR SB/SB2/SBMCV}
    Traite_8253(1193180 DIV 11000); {ON CHOISIT 11KHz...}
  InLine($FA);
  AncienVect     :=VecteurINT[$08];
  VecteurINT[$08]:=@Enregistrement_De_SB;
  InLine($FB);
END;


PROCEDURE Actualisation_Oscilloscope;
BEGIN
  Inc(x);
  IF x>XLrg THEN x:=0;
  YSauve:=y;
  IF YSauve>128+HMax THEN YSauve:=128+HMax;
  IF YSauve<128-HMax THEN YSauve:=128-HMax;
  NouveauX:=x;
  Affiche_Pixel(NouveauX+Xdeb,Sauve[x]+YMil-128,Fond);
  Affiche_Pixel(NouveauX+XDeb,YSauve+YMil-128,Blanc);
  Sauve[x]:=YSauve;
END;


PROCEDURE Restaurations;
BEGIN
  InLine($FA);
  VecteurINT[$08]:=AncienVect;
  InLine($FB);
  Traite_8253(0); {FREQUENCE INITIALE 18.2/SEC}
  Dispose(Tampon);
  TextMode(3);
END;


PROCEDURE Menu;
BEGIN
  REPEAT
    IF KeyPressed THEN
    BEGIN
      Car:=ReadKey;
      Car:=UpCase(Car);
      CASE Car OF
        'M':BEGIN
              Taille:=1;
              Marche:=True;
            END;
        'A':Marche:=False;
        'S':BEGIN
              Marche:=False;
              IF Taille>1000 THEN
              BEGIN
                InLine($FA);
                VecteurINT[$08]:=AncienVect;
                InLine($FB);
                Str(Cptr,Nbre);
                Suf:='.';
                IF Cptr<100 THEN Suf:=Suf+'0';
                IF Cptr<10  THEN Suf:=Suf+'0';
                Suf:=Suf+Nbre;
                Assign (F,NomFic+Suf);
                ReWrite(F,1);
                BlockWrite(F,Tampon^[1],Taille);
                Close  (F);
                Inc(Cptr);
                IF Cptr>999 THEN Cptr:=0;
                InLine($FA);
                VecteurINT[$08]:=@Enregistrement_De_SB;
                InLine($FB);
              END;
            END;
      END;
    END;
    Actualisation_Oscilloscope;
  UNTIL Car=#27;
END;


{=[CORPS PRINCIPAL]=========================================================}

BEGIN
  IF Init_GraphSon THEN
  BEGIN
    Initialisations;
    Menu;
    Restaurations;
  END;
END.