UNIT SYNTHE;


INTERFACE

PROCEDURE DigitRAWMono(Sample:STRING;Frequence,duree:WORD);
PROCEDURE InstSAMMono(Sample:STRING;Frequence,duree:WORD);
PROCEDURE Mix2SAMMono(Sample1,Sample2:STRING;Frequence,duree:WORD);
PROCEDURE Mix2SAMStereo(Sample1,Sample2:STRING;Frequence,duree:WORD);


IMPLEMENTATION

USES CRT,SB_DMA;

CONST
  NumberOctaves = 4;
  NumberNotes   = 12;

TYPE
  TPeriodSet = ARRAY[1..NumberOctaves] OF      {Octave}
               ARRAY[1..NumberNotes  ] OF WORD;{Note}

CONST
  {Les diffrentes valeurs des notes (pas du tout en Hertz!)}
  TabNotes : TPeriodSet = (
  {  C    C#   D    D#   E    F    F#   G    G#   A    A#   B }
  ($1AC,$194,$17D,$168,$154,$141,$12F,$11E,$10E,$0FE,$0F0,$0E3),
  ($0D6,$0CA,$0BF,$0B4,$0AA,$0A0,$097,$08F,$087,$07F,$078,$071),
  ($06B,$065,$05F,$05A,$055,$050,$04C,$047,$043,$040,$03C,$039),
  ($035,$032,$030,$02D,$02A,$028,$026,$024,$022,$020,$01E,$01C)
  );

  Gamme  :ARRAY[1..7] OF BYTE=(1,3,5,6,8,10,12);
  NomNote:ARRAY[1..12] OF STRING=(
  'DO  ','DO# ','RE  ','RE# ','MI  ','FA  ','FA# ','SOL ','SOL#','LA  ',
  'LA# ','SI  ');

VAR
  inst1,inst2,tmp:Pointer;
  Fic1,Fic2      :FILE;
  step,aux,count :REAL;
  multi          :LongInt;
  BuffPos        :WORD;
  InstPos        :LongInt;
  Octa,Note      :BYTE;
  Touche         :Char;
  Segi1,Ofsi1,
  Segi2,Ofsi2,
  Segb,Ofsb      :WORD;
  i,c            :WORD;
  size           :WORD;
  size1,size2,
  size3          :LongInt;


PROCEDURE ProcGenerale(Sample1,Sample2:STRING;Frequence,code,duree:WORD);
BEGIN
  ClrScr;
  {Le fichier du 1er chantillon d'instrument}
  Assign(Fic1,Sample1);{Voix droite si Stro}
  Reset(Fic1,1);
  size1:=FileSize(Fic1);
  GetMem(inst1,size1);
  {Le fichier du 2me chantillon d'instrument}
  IF code<2 THEN
  BEGIN
    Assign(Fic2,Sample2);{Voix gauche si Stro}
    Reset(Fic2,1);
    size2:=FileSize(Fic2);
    GetMem(inst2,size2);
  END;
  IF code=2 THEN
    size2:=size1;
  {Allocation & attribution de la taille du 1er chantillon}
  WHILE ((Seg(inst1^) SHL 4 +Ofs(inst1^))>(65500-size1)) DO
  BEGIN                   {Les donnes de l'chantillon}
    FreeMem(inst1,size1); {ne doivent pas se chevaucher}
    GetMem(tmp,1);        {sur +sieurs segments! Le DMA}
    GetMem(inst1,size1);  {n'aime pas a du tout...    }
  END;
  BlockRead(Fic1,inst1^,size1);
  Close(Fic1);
  Segi1:=MemW[Seg(inst1):Ofs(inst1)+2];
  Ofsi1:=MemW[Seg(inst1):Ofs(inst1)];
  {Allocation & attribution de la taille du 2me chantillon}
  IF code<2 THEN
  BEGIN
    WHILE ((Seg(inst2^) SHL 4 +Ofs(inst2^))>(65500-size2)) DO
    BEGIN
      FreeMem(inst2,size2);
      GetMem(tmp,1);
      GetMem(inst2,size2);
    END;
    BlockRead(Fic2,inst2^,size2);
    Close(Fic2);
    Segi2:=MemW[Seg(inst2):Ofs(inst2)+2];
    Ofsi2:=MemW[Seg(inst2):Ofs(inst2)];
  END;
  {Allocation du tampon rsultat pour le mixage et le calcul de la note}
  IF code=1 THEN
    size3:=64000
  ELSE
    size3:=32000;
  IF code=3 THEN
    size3:=size1;
  GetMem(buffer,size3);
  WHILE ((Seg(buffer^) SHL 4 +Ofs(buffer^))>(65500-size3)) DO
  BEGIN
    FreeMem(buffer,size3);
    GetMem(tmp,1);
    GetMem(buffer,size3);
  END;
  Segb :=MemW[Seg(buffer):Ofs(buffer)+2];
  Ofsb :=MemW[Seg(buffer):Ofs(buffer)];
  {Conversion des donnes SAM de octets signs --> octets non signs}
  IF code<3 THEN
    FOR i:=1 TO size1 DO
      Mem[Segi1:Ofsi1+i]:=Mem[Segi1:Ofsi1+i]+128;
  IF code<2 THEN
    FOR i:=1 TO size2 DO
      Mem[Segi2:Ofsi2+i]:=Mem[Segi2:Ofsi2+i]+128;
  {Dtection SB et Mixer. Si Mixer alors Volume maximum!}
  DetectionSBetMixer;
  VolMax;
  {Activation du Haut-Parleur}
  SpeakerON;
  {Calcul du facteur d'adaptation  la synthse d'une note pour toute
   frquence d'mission}
  IF code<3 THEN
    count:=902000/Frequence;
  {AFFICHAGE DE QUELQUES INFOS}
  CASE code OF
    0:WriteLn('Frquence: ',Frequence:5,'   Adaptation:',Count,
              '  Mix2SAMMono');
    1:WriteLn('Frquence: ',Frequence*2:5,'   Adaptation:',Count,
              '  Mix2SAMStro');
    2:WriteLn('Frquence: ',Frequence:5,'   Adaptation:',Count,
              '  InstSAMMono');
    3:WriteLn('Frquence: ',Frequence:5,'   Adaptation: NEANT',
              '  DigitRAWMono');
  END;
  IF code<3 THEN
  BEGIN
    FOR octa:=1 TO 4 Do {Octaves 1 a 4}
    BEGIN
      FOR note:=1 TO 7 Do {Notes 1 a 7 (DO a SI)}
      BEGIN
        BuffPos :=0;
        {Calcul du Pas servant  "tirer" ou "rtrcir" un chantillon
         afin de gnrer la bonne note  partir des donnes digitales
         d'un instrument}
        step    :=count/TabNotes[octa,Gamme[note]];
        aux     :=0;
        REPEAT
          aux:=aux+step;
          {Quand l'incrment du Pas dpasse la taille d'un des deux
           instruments on arrte la gnration de l'chantillon calcul}
          IF ((aux>size1) OR (aux>size2)) THEN
            aux:=0
          ELSE
          BEGIN
            InstPos:=Trunc(aux);
            CASE code OF
              0:BEGIN
                  {Mixage des bonnes donnes des deux
                   chantillons dans Buffer}
                  Move(Mem[Segi1:Ofsi1+InstPos],Mem[Segb:Ofsb+BuffPos],1);
                  Mem[Segb:Ofsb+BuffPos]:=(Mem[Segi2:Ofsi2+InstPos]+
                                           Mem[Segb:Ofsb+BuffPos]) SHR 1;
                END;
              1:BEGIN
                  {Alternance des bonnes donnes des deux
                   chantillons pour Stro dans Buffer}
                  Move(Mem[Segi1:Ofsi1+InstPos],Mem[Segb:Ofsb+BuffPos],1);
                  Move(Mem[Segi2:Ofsi2+InstPos],Mem[Segb:Ofsb+BuffPos+1],1);
                  Inc(BuffPos);
                END;
              2:BEGIN
                  {Affectation directe des bonnes donnes de
                   l'chantillon dans Buffer}
                  Move(Mem[Segi1:Ofsi1+InstPos],Mem[Segb:Ofsb+BuffPos],1);
                END;
            END;
            Inc(BuffPos);
          END;
        UNTIL ((aux=0) OR (BuffPos>size3));
        GoToXY(1,2);
        WriteLn('Octave: ',octa,'    Note: ',NomNote[Gamme[note]],
                '   Pas:',step);
        {Mode Stro sans filtre}
        IF code=1 THEN
        BEGIN
          Stereo;
          {On joue l'chantillon rsultant calcul}
          InitPlayBack(buffer,BuffPos-2,Frequence*2);
        END
        ELSE
        BEGIN
          aux:=0;
          InitPlayBack(buffer,BuffPos-1,Frequence);
        END;
        {On temporise fictivement pendant le PlayBack}
        Delay(duree);
        {On arrete explicitement le transfert DMA vers la SB}
        ArreteDMA;
      END;
    END;
  END
  ELSE
  BEGIN
    Move(Mem[Segi1:Ofsi1],Mem[Segb:Ofsb],size1);
    {On joue l'chantillon tel quel}
    InitPlayBack(buffer,size1-1,Frequence);
    {On temporise fictivement pendant le PlayBack}
    Delay(duree);
    {On arrte explicitement le transfert DMA vers la SB}
    ArreteDMA;
  END;
  {Dsactivation du Haut-Parleur}
  SpeakerOFF;
  {Restauration des pointeurs}
  FreeMem(inst1,size1);
  IF code<2 THEN
    FreeMem(inst2,size2);
  FreeMem(buffer,size3);
END;


PROCEDURE DigitRAWMono(Sample:STRING;Frequence,duree:WORD);
BEGIN
  IF Blaster THEN
    ProcGenerale(Sample,'',Frequence,3,duree);
END;


PROCEDURE InstSAMMono(Sample:STRING;Frequence,duree:WORD);
BEGIN
  IF Blaster THEN
    ProcGenerale(Sample,'',Frequence,2,duree);
END;


PROCEDURE Mix2SAMMono(Sample1,Sample2:STRING;Frequence,duree:WORD);
BEGIN
  IF Blaster THEN
    ProcGenerale(Sample1,Sample2,Frequence,0,duree);
END;


PROCEDURE Mix2SAMStereo(Sample1,Sample2:STRING;Frequence,duree:WORD);
BEGIN
  IF Blaster THEN
    ProcGenerale(Sample1,Sample2,Frequence,1,duree);
END;



END.