UNIT SB_DMA;


INTERFACE

VAR
 s            :ARRAY[1..7] OF Pointer;
 sequence     :BYTE;
 sounds,
 buffer       :Pointer;
 snd,sze,sizes:WORD;
 IRQ,DMA      :BYTE;
 PortBase     :WORD;
 Blaster,Mixer:Boolean;
 err          :Integer;

PROCEDURE AskIRQDMA;
PROCEDURE DetectionSBetMixer;
PROCEDURE VolMax;
PROCEDURE Stereo;
PROCEDURE SpeakerON;
PROCEDURE SpeakerOFF;
PROCEDURE ArreteDMA;
PROCEDURE InitPlayback(son:Pointer; taille:WORD; frequence:WORD);
PROCEDURE InitPlayback7(son:Pointer; taille:WORD; frequence:WORD);
PROCEDURE FinPlayBack7;


IMPLEMENTATION

USES CRT,DOS;

VAR
 DSP_RESET,DSP_READ_DATA,
 DSP_WRITE_DATA,
 DSP_WRITE_STATUS,
 DSP_DATA_AVAIL,i,Offse  :WORD;
 OldIRQ                  :Pointer;
 Page                    :BYTE;


PROCEDURE AskIRQDMA;
VAR car:Char;
BEGIN
  ClrScr;
  GoToXY(1,1);
  Write('Possdez-vous une carte compatible SoundBlaster (O/N)? ');
  REPEAT
    car:=ReadKey;
    car:=UpCase(Car);
  UNTIL ((car='O') OR (car='N'));
  GoToXY(56,1);
  WriteLn(car);
  Delay(300);
  DetectionSBetMixer;
  IF car='O' THEN
  BEGIN
    {Interrogation ligne IRQ}
    GoToXY(1,2);
    Write('Numro d''IRQ (2=IRQ2, 3=IRQ3, 5=IRQ5, 7=IRQ7, 0=IRQ10)? ');
    REPEAT
      car:=ReadKey;
      car:=UpCase(Car);
    UNTIL ((car='2') OR (car='3') OR (car='5')
                     OR (car='7') OR (car='0'));
    Val(car,IRQ,err);
    IF IRQ=0 THEN IRQ:=10;
    GoToXY(57,2);
    WriteLn(IRQ);
    {Interrogation canal DMA}
    GoToXY(1,3);
    Write('Canal DMA (0=DMA0, 1=DMA1, 3=DMA3)? ');
    REPEAT
      car:=ReadKey;
      car:=UpCase(Car);
    UNTIL ((car='0') OR (car='1') OR (car='3'));
    Val(car,DMA,err);
    GoToXY(37,3);
    WriteLn(DMA);
    Delay(300);
  END;
END;


PROCEDURE EcritDSP(valeur:BYTE);
BEGIN
  WHILE Port[DSP_WRITE_STATUS] AND $80<>0 DO;
  Port[DSP_WRITE_DATA]:=valeur;
END;


FUNCTION LitDSP:BYTE;
BEGIN
  WHILE Port[DSP_DATA_AVAIL] AND $80=0 DO;
  LitDSP:=Port[DSP_READ_DATA];
END;


PROCEDURE EcritDAC(Commande:BYTE);
BEGIN
  EcritDSP($10);
  EcritDSP(Commande);
END;


FUNCTION LitDAC:BYTE;
BEGIN
  EcritDSP($20);
  LitDAC:=LitDSP;
END;


PROCEDURE SpeakerON;
BEGIN
  EcritDSP($D1);
END;


PROCEDURE SpeakerOFF;
BEGIN
  EcritDSP($D3);
END;


PROCEDURE ArreteDMA;
BEGIN
  EcritDSP($D0);
END;


PROCEDURE SbWriteMixerReg(Reg,Val:BYTE);
BEGIN
  Port[$204+PortBase*16]:=Reg;
  Port[$205+PortBase*16]:=Val;
END;


FUNCTION SbReadMixerReg(Reg:BYTE):BYTE;
BEGIN
  Port[$204+PortBase*16]:=Reg;
  SbReadMixerReg:=Port[$205+PortBase*16];
END;


FUNCTION InitDSP(base:WORD):BOOLEAN;{1<=base<=6 pour 210h  260h}
BEGIN
  base:=base*$10;
  {Calculs des adresses utiles}
  DSP_RESET       :=base+$206;
  DSP_READ_DATA   :=base+$20A;
  DSP_WRITE_DATA  :=base+$20C;
  DSP_WRITE_STATUS:=base+$20C;
  DSP_DATA_AVAIL  :=base+$20E;
  {Reinitialise le DSP}
  Port[DSP_RESET]:=1;
  Delay(60);
  Port[DSP_RESET]:=0;
  Delay(60);
  IF (Port[DSP_DATA_AVAIL] AND $80=$80) AND (Port[DSP_READ_DATA]=$AA) THEN
    InitDSP:=True
  ELSE
    InitDSP:=False;
END;


PROCEDURE DetectionSBetMixer;
BEGIN
  Blaster :=TRUE;
  PortBase:=0;
  REPEAT
    Inc(PortBase);
  UNTIL ((InitDSP(PortBase)=True) OR (PortBase>6));
  IF PortBase>6 THEN Blaster:=FALSE;
  IF Blaster THEN
  BEGIN
    SbWriteMixerReg($22,$F3);
    IF SbReadMixerReg($22)=$F3 THEN
    BEGIN
      Mixer:=True;
      SbWriteMixerReg($22,$99);
      SbWriteMixerReg($04,$99);
    END;
  END;
END;


PROCEDURE VolMax;
BEGIN
  IF Mixer THEN
  BEGIN
    {Reset puce Mixer}
    SbWriteMixerReg($00,$00);
    {Master volume maxi}
    SbWriteMixerReg($22,$FF);
    {Voice volume maxi}
    SbWriteMixerReg($04,$FF);
  END;
END;


PROCEDURE Stereo;
BEGIN
  IF Mixer THEN
    SbWriteMixerReg($0E,$22);
END;


PROCEDURE Playback;INTERRUPT; {Routine de transfert simple via le DMA}
VAR
  recu       :BYTE;
BEGIN
  {Accus de rception}
  recu:=Port[DSP_DATA_AVAIL];
  {Calcul de l'adresse Physique et Page de la sequence}
  offse :=Seg(sounds^) SHL 4+Ofs(sounds^);
  page  :=(Seg(sounds^)+Ofs(sounds^) SHR 4) SHR 12;
  {Prparation du DMAC pour le transfert}
  Port[$0A]:=DMA+4;
  Port[$0C]:=0;
  Port[$0B]:=$49;{Via DAC}
  Port[DMA SHL 1]:=Lo(offse);
  Port[DMA SHL 1]:=Hi(offse);
  IF DMA=0 THEN Port[$87]:=page;
  IF DMA=1 THEN Port[$83]:=page;
  IF DMA=3 THEN Port[$82]:=page;
  Port[DMA SHL 1 +1]:=Lo(sizes);
  Port[DMA SHL 1 +1]:=Hi(sizes);
  Port[$0A]:=DMA;{Canal DMA}
  {Activation du transfert par le DAC}
  EcritDSP($14);
  EcritDSP(Lo(sizes));
  EcritDSP(Hi(sizes));
  sounds:=buffer;
  {Avis de fin d'interruption au contrleur d'INT}
  Port[$20]:=$20;
END;


PROCEDURE Playback7;INTERRUPT;{Routine greffe sur l'IRQ et dclenche}
VAR                           {par le  DSP  de  la carte  SoundBlaster}
  recu       :BYTE;           {en fin de transfert de DMA             }
BEGIN
  {Accus de rception}
  recu:=Port[DSP_DATA_AVAIL];
  {Calcul de l'adresse Physique et Page de la sequence}
  offse :=Seg(sounds^) SHL 4+Ofs(sounds^);
  page  :=(Seg(sounds^)+Ofs(sounds^) SHR 4) SHR 12;
  {Prparation du DMAC pour le transfert}
  Port[$0A]:=DMA+4;
  Port[$0C]:=0;
  Port[$0B]:=$49;{Via DAC}
  Port[DMA SHL 1]:=Lo(offse );
  Port[DMA SHL 1]:=Hi(offse );
  IF DMA=0 THEN Port[$87]:=page;
  IF DMA=1 THEN Port[$83]:=page;
  IF DMA=3 THEN Port[$82]:=page;
  Port[DMA SHL 1 +1]:=Lo(sizes);
  Port[DMA SHL 1 +1]:=Hi(sizes);
  Port[$0A]:=DMA;{Canal DMA}
  {Activation du transfert par le DAC}
  EcritDSP($14);
  EcritDSP(Lo(sizes));
  EcritDSP(Hi(sizes));
  {Actualisation de la squence  jouer; ici on est en tche de fond}
  {Le morceau  est constitu d'un assemblage de 44 patterns parmi 7,}
  {pour une dure approximative  de 1mn20s  11KHz.  Le bouclage est}
  {effectif aprs le 44e pattern                                    }
  Inc(sequence);
  IF sequence>44 THEN sequence:=1;
  CASE sequence OF
   1..4                       :BEGIN
                                 Snd:=1;
                                 Sze:=19976;
                               END;
   8,13..15,17..19,30,32,38,40:BEGIN
                                 Snd:=2;
                                 Sze :=20104;
                               END;
   5..7,9..11,41              :BEGIN
                                 Snd:=3;
                                 Sze :=19976;
                               END;
   12,16,20,33..36,42..44     :BEGIN
                                 Snd:=4;
                                 Sze :=20104;
                               END;
   21..23,25..27,29,37        :BEGIN
                                 Snd:=5;
                                 Sze :=20104;
                               END;
   24                         :BEGIN
                                 Snd:=6;
                                 Sze :=20104;
                               END;
   28,31,39                   :BEGIN
                                 Snd:=7;
                                 Sze :=20040;
                               END;
  END;
  sounds:=s[snd];
  sizes :=sze-1;{ajustement de la taille  -1}
  {Avis de fin d'interruption au contrleur d'INT}
  Port[$20]:=$20;
END;


PROCEDURE ActiveIRQ(i:WORD);
BEGIN
  IF i<8 THEN
    PORT[$21]:=PORT[$21] AND (NOT (1 SHL i))
  ELSE
  BEGIN
    PORT[$A1]:=PORT[$A1] AND (NOT (1 SHL (i-8)));
    PORT[$21]:=PORT[$21] AND (NOT (1 SHL 2));
  END;
END;


PROCEDURE DesactiveIRQ(i:WORD);
BEGIN
  IF i<8 THEN
    PORT[$21]:=PORT[$21] OR (1 SHL i)
  ELSE
  BEGIN
    PORT[$A1]:=PORT[$A1] OR (1 SHL (i-8))
  END;
END;


FUNCTION ChangeVecteurIRQ(i:WORD; Vec:POINTER):POINTER;
VAR
 p:POINTER;
 j:WORD;
BEGIN
  IF i<8 THEN
    j:=i+$08
  ELSE
    j:=i+$68;
  GetIntVec(j,p);
  SetIntVec(j,Vec);
  ChangeVecteurIRQ:=p;
END;


PROCEDURE InitPlayback(son:Pointer; taille:WORD; frequence:WORD);
VAR time_constant:WORD;
BEGIN
  {Dfinit la frquence}
  time_constant:=256-1000000 DIV frequence;
  EcritDSP($40);
  EcritDSP(time_constant);
  {ajustement de la taille  -1 pour squence simple}
  taille:=taille-1;
  sounds:=son;
  offse :=Seg(sounds^) SHL 4+Ofs(sounds^);
  page  :=(Seg(sounds^)+Ofs(sounds^) SHR 4) SHR 12;
  Port[$0A]:=DMA+4;
  Port[$0C]:=0;
  Port[$0B]:=$49;
  Port[DMA SHL 1]:=Lo(offse);
  Port[DMA SHL 1]:=Hi(offse);
  IF DMA=0 THEN Port[$87]:=page;
  IF DMA=1 THEN Port[$83]:=page;
  IF DMA=3 THEN Port[$82]:=page;
  Port[DMA SHL 1 +1]:=Lo(taille);
  Port[DMA SHL 1 +1]:=Hi(taille);
  Port[$0A]:=DMA;
  EcritDSP($14);
  EcritDSP(Lo(taille));
  EcritDSP(Hi(taille));
END;


PROCEDURE InitPlayback7(son:Pointer; taille:WORD; frequence:WORD);
VAR time_constant:WORD;
BEGIN
  {Dfinit la frquence}
  time_constant:=256-1000000 DIV frequence;
  EcritDSP($40);
  EcritDSP(time_constant);
  SpeakerON;
  {ajustement de la taille  -1 pour la 1re squence}
  taille:=taille-1;
  sounds:=son;
  offse :=Seg(sounds^) SHL 4+Ofs(sounds^);
  page  :=(Seg(sounds^)+Ofs(sounds^) SHR 4) SHR 12;
  Port[$0A]:=DMA+4;
  Port[$0C]:=0;
  Port[$0B]:=$49;
  Port[DMA SHL 1]:=Lo(offse);
  Port[DMA SHL 1]:=Hi(offse);
  IF DMA=0 THEN Port[$87]:=page;
  IF DMA=1 THEN Port[$83]:=page;
  IF DMA=3 THEN Port[$82]:=page;
  Port[DMA SHL 1 +1]:=Lo(taille);
  Port[DMA SHL 1 +1]:=Hi(taille);
  Port[$0A]:=DMA;
  {La routine PlayBack est sur l'IRQ}
  OldIRQ:=ChangeVecteurIRQ(IRQ,@PlayBack7);
  ActiveIRQ(IRQ);
  EcritDSP($14);
  EcritDSP(Lo(taille));
  EcritDSP(Hi(taille));
  {Prparation pour la sequence suivante (joue alors par la routine IRQ)}
  Sequence:=2;
  snd     :=1;
  sze     :=19976;
  sounds  :=s[snd];
  sizes   :=sze-1;
END;


PROCEDURE FinPlayBack7;
VAR p:Pointer;
BEGIN
  ArreteDMA;
  DesactiveIRQ(IRQ);
  p:=ChangeVecteurIRQ(IRQ,OldIRQ);
  SpeakerOFF;
END;



BEGIN
  Mixer   :=FALSE;
  Blaster :=FALSE;
  IRQ     :=7;
  DMA     :=1;
  PortBase:=2;{pour 220h}
END.