
 ; ********************************************* sound emulation
        IDEAL

EXTRN psgregs:WORD,psgregmod:WORD
EXTRN PSGcount:WORD
EXTRN SBinstalled:WORD,noisy:WORD,SBport:WORD,usesound:WORD,sbdelay:WORD
EXTRN intflag:WORD

EXTRN GUS_Reset:PROC,GUS_DoSound:PROC
PUBLIC SB_Reset,DoSound,RethinkPSG

P386

GROUP   DGROUP _stack,_data

SEGMENT _text PAGE PUBLIC 'CODE'
ASSUME CS:_text
ASSUME DS:DGROUP
SB_Oct2 EQU     13f000h

SB_Reset:
        MOV     [psgcount],0
        CMP     [SBinstalled],0
        JE      SBRES_End
        CMP     [SBinstalled],2
        JE      GUS_Reset
        MOV     AX,0
SBRES_Loop:
        PUSH    AX
        CALL    SetSBReg
        POP     AX
        INC     AH
        CMP     AH,0F6h
        JNE     SBRES_Loop

        MOV     AX,2001h
        CALL    SetSBReg
        MOV     AX,2101h
        CALL    SetSBReg
        MOV     AX,2201h
        CALL    SetSBReg

        MOV     AX,0C000h
        CALL    SetSBReg
        MOV     AX,0C100h
        CALL    SetSBReg
        MOV     AX,0C200h
        CALL    SetSBReg

        MOV     AX,40ffh
        CALL    SetSBReg
        MOV     AX,41ffh
        CALL    SetSBReg
        MOV     AX,42ffh
        CALL    SetSBReg

        MOV     AX,60f0h
        CALL    SetSBReg
        MOV     AX,61f0h
        CALL    SetSBReg
        MOV     AX,62f0h
        CALL    SetSBReg
        MOV     AX,70f0h
        CALL    SetSBReg
        MOV     AX,71f0h
        CALL    SetSBReg
        MOV     AX,72f0h
        CALL    SetSBReg

        MOV     AX,80f0h
        CALL    SetSBReg
        MOV     AX,81f0h
        CALL    SetSBReg
        MOV     AX,82f0h
        CALL    SetSBReg
        MOV     AX,90f0h
        CALL    SetSBReg
        MOV     AX,91f0h
        CALL    SetSBReg
        MOV     AX,92f0h
        CALL    SetSBReg

        MOV     AX,2301h
        CALL    SetSBReg
        MOV     AX,2401h
        CALL    SetSBReg
        MOV     AX,2501h
        CALL    SetSBReg

        MOV     AX,63f0h
        CALL    SetSBReg
        MOV     AX,64f0h
        CALL    SetSBReg
        MOV     AX,65f0h
        CALL    SetSBReg

        MOV     AX,83Ffh
        CALL    SetSBReg
        MOV     AX,84Ffh
        CALL    SetSBReg
        MOV     AX,85Ffh
        CALL    SetSBReg

        MOV     AX,00120h
        CALL    SetSBReg
        MOV     AX,0E002h        ; experimental: waveform select
        CALL    SetSBReg
        MOV     AX,0E102h
        CALL    SetSBReg
        MOV     AX,0E202h
        CALL    SetSBReg

SBRES_End:
        RET

RethinkPSG:                             ; this is here for sampling
        PUSHAD                          ; word accesses. The CPC makes
        CMP     [psgregmod],0ff00h      ; two byte accesses, but we wait
        JE      RPSG_C0                 ; a little to give it time to send
        CMP     [psgregmod],00ffh       ; the other half as well
        JNE     RPSG_C0OK
RPSG_C0:
        MOV     BP,0
        MOV     [psgregmod],0ffffh
        CALL    DoSound
RPSG_C0OK:
        CMP     [psgregmod+2],0ff00h
        JE      RPSG_C1
        CMP     [psgregmod+2],00ffh
        JNE     RPSG_C1OK
RPSG_C1:
        MOV     BP,2
        MOV     [psgregmod+2],0ffffh
        CALL    DoSound
RPSG_C1OK:
        CMP     [psgregmod+4],0ff00h
        JE      RPSG_C2
        CMP     [psgregmod+4],00ffh
        JNE     RPSG_C2OK
RPSG_C2:
        MOV     BP,4
        MOV     [psgregmod+4],0ffffh
        CALL    DoSound
RPSG_C2OK:
        POPAD
        RET

DoSound:
        CMP     [SBInstalled],2
        JE      GUS_DoSound
        PUSHAD
        CMP     [usesound],0
        JE      SOUND_End
        CMP     BP,0
        JE      SOUND_SetPer1
        CMP     BP,1
        JE      SOUND_SetPer1
        CMP     BP,2
        JE      SOUND_SetPer2
        CMP     BP,3
        JE      SOUND_SetPer2
        CMP     BP,4
        JE      SOUND_SetPer3
        CMP     BP,5
        JE      SOUND_SetPer3
        CMP     BP,6
        JE      SOUND_SetNoise
        CMP     BP,7
        JE      SOUND_SetState
        CMP     BP,8
        JE      SOUND_SetVolA
        CMP     BP,9
        JE      SOUND_SetVolB
        CMP     BP,10
        JE      SOUND_SetVolC
        JMP     SOUND_End
SOUND_SetNoise:
        MOV     AL,[BYTE PTR psgregs+6]
        AND     AL,1fh
        JNZ     SOUND_NoisePerOK
        INC     AL
SOUND_NoisePerOK:
        MOV     AL,21h
        OR      AL,20h
        MOV     AH,[BYTE PTR psgregs+7]
        XOR     AH,255
        AND     AH,38h
        JNZ     SOUND_NoiseOK
        XOR     AL,AL
SOUND_NoiseOK:
        CMP     [sbnoisereg],AL
        JE      SOUND_NoiseRegOK
        MOV     [sbnoisereg],AL
        CALL    SB_SetNoise
        MOV     AL,[BYTE PTR psgregs+6]
        AND     AL,1Ch
        CMP     [SBnoiseper],AL
        JE      SOUND_End
        MOV     [SBnoiseper],AL
        CALL    SB_SetNoisePer
        JMP     SOUND_End
SOUND_NoiseRegOK:
        JMP     SOUND_End
SOUND_SetVolA:
        MOV     AL,[BYTE PTR psgregs+8]
        BT      AX,4
        JNC     SOUND_VolA_OK
        MOV     AX,7
SOUND_VolA_OK:
        XOR     AL,255
        AND     AL,15
        ADD     AL,AL
        CMP     AL,[sbvolregs]
        JE      SOUND_End
        MOV     [sbvolregs],AL
        CALL    SB_SetVolA
        JMP     SOUND_End
SOUND_SetVolB:
        MOV     AL,[BYTE PTR psgregs+9]
        BT      AX,4
        JNC      SOUND_VolB_OK
        MOV     AX,7
SOUND_VolB_OK:
        XOR     AL,255
        AND     AL,15
        ADD     AL,AL
        CMP     AL,[sbvolregs+1]
        JE      SOUND_End
        MOV     [sbvolregs+1],AL
        CALL    SB_SetVolB
        JMP     SOUND_End
SOUND_SetVolC:
        MOV     AL,[BYTE PTR psgregs+10]
        BT      AX,4
        JNC     SOUND_VolC_OK
        MOV     AX,7
SOUND_VolC_OK:
        XOR     AL,255
        AND     AL,15
        ADD     AL,AL
        CMP     AL,[sbvolregs+2]
        JE      SOUND_End
        MOV     [sbvolregs+2],AL
        CALL    SB_SetVolC
        JMP     SOUND_End
SOUND_SetPer1:
        CMP     [psgregmod],0ffffh
        JNE     SOUND_SetPSGCount
        MOV     [psgregmod],0
        MOV     CX,[WORD PTR psgregs]
        AND     ECX,0fffh
        MOV     EDX,0
        MOV     EAX,SB_Oct2
        CMP     ECX,0
        JE      SOUND_SP1_ChannelOff
        DIV     ECX
        JMP     SOUND_SP1_ValueCalced
SOUND_SP1_ChannelOff:
        XOR     EAX,EAX
SOUND_SP1_ValueCalced:
        MOV     BX,[sbperregs]
        AND     BX,2000h
        XOR     CX,CX
SOUND_SP1_CalcOctave:
        CMP     CX,1C00h
        JNC     SOUND_SP1_OctaveOK
        CMP     EAX,400h
        JC      SOUND_SP1_OctaveOK
        ADD     CX,400h
        SHR     EAX,1
        JMP     SOUND_SP1_CalcOctave
SOUND_SP1_OctaveOK:
        AND     AX,3ffh
        OR      BX,CX
        OR      BX,AX
        CMP     BX,[sbperregs]
        JE      SOUND_End
        MOV     [sbperregs],BX
        CALL    SB_SetPerA
        JMP     SOUND_End
SOUND_SetPer2:
        CMP     [psgregmod+2],0ffffh
        JNE     SOUND_SetPSGCount
        MOV     [psgregmod+2],0
        MOV     CX,[WORD PTR psgregs+2]
        AND     ECX,0fffh
        MOV     EDX,0
        MOV     EAX,SB_Oct2
        CMP     ECX,0
        JE      SOUND_SP2_ChannelOff
        DIV     ECX
        JMP     SOUND_SP2_ValueCalced
SOUND_SP2_ChannelOff:
        XOR     EAX,EAX
SOUND_SP2_ValueCalced:
        MOV     BX,[sbperregs+2]
        AND     BX,2000h
        XOR     CX,CX
SOUND_SP2_CalcOctave:
        CMP     CX,1C00h
        JNC     SOUND_SP2_OctaveOK
        CMP     EAX,400h
        JC      SOUND_SP2_OctaveOK
        ADD     CX,400h
        SHR     EAX,1
        JMP     SOUND_SP2_CalcOctave
SOUND_SP2_OctaveOK:
        AND     AX,3ffh
        OR      BX,CX
        OR      BX,AX
        CMP     BX,[sbperregs+2]
        JE      SOUND_End
        MOV     [sbperregs+2],BX
        CALL    SB_SetPerB
        JMP     SOUND_End
SOUND_SetPer3:
        CMP     [psgregmod+4],0ffffh
        JNE     SOUND_SetPSGCount
        MOV     [psgregmod+4],0
        MOV     CX,[WORD PTR psgregs+4]
        AND     ECX,0fffh
        MOV     EDX,0
        MOV     EAX,SB_Oct2
        CMP     ECX,0
        JE      SOUND_SP3_ChannelOff
        DIV     ECX
        JMP     SOUND_SP3_ValueCalced
SOUND_SP3_ChannelOff:
        XOR     EAX,EAX
SOUND_SP3_ValueCalced:
        MOV     BX,[sbperregs+4]
        AND     BX,2000h
        XOR     CX,CX
SOUND_SP3_CalcOctave:
        CMP     CX,1C00h
        JNC     SOUND_SP3_OctaveOK
        CMP     EAX,400h
        JC      SOUND_SP3_OctaveOK
        ADD     CX,400h
        SHR     EAX,1
        JMP     SOUND_SP3_CalcOctave
SOUND_SP3_OctaveOK:
        AND     AX,3ffh
        OR      BX,CX
        OR      BX,AX
        CMP     BX,[sbperregs+4]
        JE      SOUND_End
        MOV     [sbperregs+4],BX
        CALL    SB_SetPerC
        JMP     SOUND_End
SOUND_SetState:
        MOV     AH,[BYTE PTR psgregs+7]
        XOR     AH,0ffh
        AND     AH,1
        SHL     AH,5
        MOV     BX,[SBperregs]
        AND     BX,1fffh
        OR      BH,AH
        CMP     BX,[SBperregs]
        JE      SOUND_SS_AOK
        MOV     [SBperregs],BX
        CALL    SB_SetChannelA
SOUND_SS_AOK:
        MOV     AH,[BYTE PTR psgregs+7]
        XOR     AH,0ffh
        AND     AH,2
        SHL     AH,4
        MOV     BX,[SBperregs+2]
        AND     BX,1fffh
        OR      BH,AH
        CMP     BX,[SBperregs+2]
        JE      SOUND_SS_BOK
        MOV     [SBperregs+2],BX
        CALL    SB_SetChannelB
SOUND_SS_BOK:
        MOV     AH,[BYTE PTR psgregs+7]
        XOR     AH,0ffh
        AND     AH,4
        SHL     AH,3
        MOV     BX,[SBperregs+4]
        AND     BX,1fffh
        OR      BH,AH
        CMP     BX,[SBperregs+4]
        JE      SOUND_SS_COK
        MOV     [SBperregs+4],BX
        CALL    SB_SetChannelC
SOUND_SS_COK:
        JMP     SOUND_SetNoise
SOUND_SetPSGcount:
        OR      [intflag],4
        CMP     [PSGcount],0
        JNE     SOUND_End
        MOV     [PSGcount],50
SOUND_End:
        POPAD
        RET

SB_SetNoise:
        CMP     [noisy],0
        JE      SB_SNOI_Ret
        CALL    SB_SetNoiseVol
        MOV     AH,0BDh
        MOV     AL,[sbnoisereg]
        JMP     SetSBReg
SB_SNOI_Ret:
        MOV     AH,0BDh
        MOV     AL,0
        JMP     SetSBReg

SB_SetNoiseVol:
        CMP     [noisy],0
        JE      SB_SNOI_Ret
        MOV     AL,0
        BT      [WORD PTR PSGregs+7],3
        JC      SB_SN_A0
        MOV     AH,[BYTE PTR PSGregs+8]
        AND     AH,15
        ADD     AL,AH
SB_SN_A0:
        BT      [WORD PTR PSGregs+7],4
        JC      SB_SN_B0
        MOV     AH,[BYTE PTR PSGregs+9]
        AND     AH,15
        ADD     AL,AH
SB_SN_B0:
        BT      [WORD PTR PSGregs+7],5
        JC      SB_SN_C0
        MOV     AH,[BYTE PTR PSGregs+10]
        AND     AH,15
        ADD     AL,AH
SB_SN_C0:
        SHL     AL,3
        CMP     AL,40h
        JC      SB_SN_OK
        MOV     AL,3fh
SB_SN_OK:
        MOV     AH,51h
        XOR     AL,3fh
        CALL    SetSBReg
        RET

SB_SetNoisePer:
        CMP     [noisy],0
        JE      SB_SNOI_Ret
        MOV     AX,0A700h
        CALL    SetSBReg
        MOV     AH,0B7h
        MOV     AL,[sbnoiseper]
        JMP     SetSBReg

SB_SetVolA:
        MOV     AH,43h
        MOV     AL,[SBvolregs]
        CALL    SetSBReg
        BT      [WORD PTR PSGregs+7],3
        JNC     SB_SetNoiseVol
        RET

SB_SetVolB:
        MOV     AH,44h
        MOV     AL,[SBvolregs+1]
        CALL    SetSBReg
        BT      [WORD PTR PSGregs+7],4
        JNC     SB_SetNoiseVol
        RET

SB_SetVolC:
        MOV     AH,45h
        MOV     AL,[SBvolregs+2]
        CALL    SetSBReg
        BT      [WORD PTR PSGregs+7],5
        JNC     SB_SetNoiseVol
        RET

SB_SetPerA:
        MOV     AH,0A0h
        MOV     AL,[BYTE PTR SBperregs]
        CALL    SetSBReg
        MOV     AH,0B0h
        MOV     AL,[BYTE PTR SBperregs+1]
        JMP     SetSBReg

SB_SetPerB:
        MOV     AH,0A1h
        MOV     AL,[BYTE PTR SBperregs+2]
        CALL    SetSBReg
        MOV     AH,0B1h
        MOV     AL,[BYTE PTR SBperregs+3]
        JMP     SetSBReg

SB_SetPerC:
        MOV     AH,0A2h
        MOV     AL,[BYTE PTR SBperregs+4]
        CALL    SetSBReg
        MOV     AH,0B2h
        MOV     AL,[BYTE PTR SBperregs+5]
        JMP     SetSBReg

SB_SetChannelA:
        MOV     AH,0B0h
        MOV     AL,[BYTE PTR SBperregs+1]
        JMP     SetSBReg

SB_SetChannelB:
        MOV     AH,0B1h
        MOV     AL,[BYTE PTR SBperregs+3]
        JMP     SetSBReg

SB_SetChannelC:
        MOV     AH,0B2h
        MOV     AL,[BYTE PTR SBperregs+5]
        JMP     SetSBReg

SetSBReg:
        PUSH    CX                       ; in AH: REG, AL: Data
        PUSH    DX
        PUSH    AX
        MOV     AL,AH
        MOV     DX,[SBport]
        OUT     DX,AL
        IN      AL,DX
        IN      AL,DX
        IN      AL,DX
        IN      AL,DX
        IN      AL,DX
        IN      AL,DX
        POP     AX
        INC     DX
        OUT     DX,AL
        MOV     CX,[sbdelay]
        JCXZ    SBSR_End
SBSR_Delay:
        IN      AL,DX
        LOOP    SBSR_Delay
SBSR_End:
        POP     DX
        POP     CX
        RET
ENDS

SEGMENT _data PAGE PUBLIC 'DATA'

 ; ************************************************ 8255, PSG
            EVEN
SBperregs   dw    0,0,0,0,0,0
SBvolregs   db    0,0,0,0,0,0
SBnoisereg  db    0
SBnoiseper  db    0
ENDS

SEGMENT _stack PARA STACK 'STACK'
 ; just to make it compile
ENDS

    END
